#include "menunode.h"
#include "menuroot.h"
#include "main.h"

#include <gtk90degree.h>

IceWM_CM_NAMESPACE

GtkWidget* MenuNode::editor = 0;
PropertyNode::PropDef MenuNode::prop_df [] = {
    { LABEL, PT_STRING, NULL, _("Label:"),
      _("TODO"), { 0 } },
    { ICON, PT_STRING, NULL, _("Icon:"),
      _("TODO"), { 0 } },
    { COMMAND, PT_STRING, NULL, _("Command:"),
      _("TODO"), { 0 } },
    { RESTART, PT_BOOLEAN, NULL, _("Start as window manager"),
      _("TODO"), { 0 } }
};

GtkWidget* MenuNode::prop_ed [MenuNode::PROPERTY_COUNT + 2];
GtkWidget* MenuNode::bt_icon;

GtkWidget* MenuNode::create_editor	(void) {
    if (!editor) {
        gtk_widget_ref (editor = gtk_vbox_new (FALSE, 0));
        gtk_container_set_border_width (GTK_CONTAINER (editor), 5);
    
        GtkNotebook* notebook = GTK_NOTEBOOK (gtk_notebook_new ());
	gtk_notebook_set_tab_pos (notebook, GTK_POS_RIGHT);
	gtk_notebook_set_scrollable (notebook, TRUE);
	gtk_notebook_set_tab_border (notebook, 0);
	 
        gtk_box_pack_end (GTK_BOX (editor), GTK_WIDGET (notebook), 
	                  TRUE, TRUE, 2);
			  
        gchar *titles [] = { _("Name"), _("Size"), _("Date") };
        GtkWidget* dummy_browser = gtk_clist_new_with_titles (3, titles);
        titles [0] = "Sorry MJ,"; titles [1] = titles [2] = "";
        gtk_clist_append (GTK_CLIST (dummy_browser), titles);
        titles [0] = "But this will be a file browser";
        gtk_clist_append (GTK_CLIST (dummy_browser), titles);
        gtk_clist_columns_autosize (GTK_CLIST (dummy_browser));
    
	gtk_notebook_append_page (notebook, dummy_browser,
				  gtk_90_degree_new _("Applications"));
        
        dummy_browser = gtk_clist_new (1);
        titles [0] = "Sorry MJ,";
        gtk_clist_append (GTK_CLIST (dummy_browser), titles);
        titles [0] = "But this will be a icon browser";
        gtk_clist_append (GTK_CLIST (dummy_browser), titles);
        gtk_clist_columns_autosize (GTK_CLIST (dummy_browser));
	
	gtk_notebook_append_page (notebook, dummy_browser,
				  gtk_90_degree_new _("Icons"));
    }
    
    return editor;
}

GtkWidget* MenuNode::create_top_panel (void) {
    GtkTable  *top_panel;
    
    top_panel = GTK_TABLE (gtk_table_new (2, 3, FALSE));
    gtk_table_set_col_spacing  (top_panel, 1, 4);
    
    if (prop_count () > LABEL)
        create_property_editor (LABEL, top_panel, 1, 1, 2, 3, 
	                        GTK_SIGNAL_FUNC (label_changed));

    if (prop_count () > ICON) {
        create_property_editor (ICON, top_panel, 2, 1, 2, 3, 
	                        GTK_SIGNAL_FUNC (icon_changed));
        gtk_table_attach (top_panel, bt_icon = gtk_button_new (),
                          3, 4, 1, 5, GTK_FILL, GTK_SHRINK, 4, 0);
        gtk_widget_set_usize (bt_icon, 56, 56);
    }

    if (prop_count () > COMMAND)
        create_property_editor (COMMAND, top_panel, 3, 1, 2, 3);
    if (prop_count () > RESTART)
        create_property_editor (RESTART, top_panel, 4, 1, 2, 3);
	
    return GTK_WIDGET (top_panel);
}

GtkWidget* MenuNode::get_editor (void) {
    GtkWidget *editor = create_editor ();
    GtkWidget *top_panel = get_top_panel ();
    gpointer old_panel = gtk_object_get_data (GTK_OBJECT (editor), "top-panel");

    grab_current (this);

    if (old_panel != top_panel) {
        if (old_panel != NULL)
            gtk_container_remove (GTK_CONTAINER (editor),
	                          GTK_WIDGET (old_panel));
				  
        gtk_object_set_data (GTK_OBJECT (editor), "top-panel", top_panel);
	
        if (top_panel != NULL)
            gtk_box_pack_start (GTK_BOX (editor), top_panel, FALSE, TRUE, 0);
    }
	
    synchronize_property_editors ();
    
    return editor;
}

void MenuNode::label_changed		(GtkEditable	*editable,
    					 const unsigned index) {
    string_changed (editable, index);
    Main::app.hierachy.update_tree_node ();
}

void MenuNode::icon_changed		(GtkEditable	*editable,
    					 const unsigned index) {
    string_changed (editable, index);
    current_node ()->synchronize_icon_button (bt_icon);
    Main::app.hierachy.update_tree_node ();
}

TreeNode::InsertionInfo* MenuNode::insertion_list (void) { 
    return MenuRoot::insertion_info;
}
