#include "prefsnode.h"
#include <gdk/gdkkeysyms.h>

IceWM_CM_NAMESPACE

PropertyNode::PropDef PrefsNode::prop_df [] = {
/*
 * Unused preferences:
 *
 *  inputFontName
 *  useXButton
 *  focusRootWindow
 */
    { CLICK_FOCUS, PT_BOOLEAN, "ClickToFocus",
      _("Click To Focus"), _("Focus windows by clicking"),
      { true }, 0, 0 },
    { RAISE_ONFOCUS, PT_BOOLEAN, "RaiseOnFocus",
      _("Raise On Focus"), _("Raise windows when focused"),
      { true }, 0, 0 },
    { FOCUS_ONCLICK_CLIENT, PT_BOOLEAN, "FocusOnClickClient",
      _("Focus On Click Client"), _("Focus window when client area clicked"),
      { true }, 0, 0 },
    { RAISE_ONCLICK_CLIENT, PT_BOOLEAN, "RaiseOnClickClient",
      _("Raise On Click Client"), _("Raise window when client area clicked"),
      { true }, 0, 0 },
    { RAISE_ONCLICK_BUTTON, PT_BOOLEAN, "RaiseOnClickButton",
      _("Raise On Click Button"), _("Raise window when frame button is clicked"),
      { true }, 0, 0 },
    { RAISE_ONCLICK_FRAME, PT_BOOLEAN, "RaiseOnClickFrame",
      _("Raise On Click Frame"), _("Raise window when frame border is clicked"),
      { true }, 0, 0 },
    { RAISE_ONCLICK_TITLE_BAR, PT_BOOLEAN, "RaiseOnClickTitleBar",
      _("Raise On Click Title Bar"), _("Raise window when title bar is clicked"),
      { true }, 0, 0 },
    { PASS_FIRST_CLICK_TOCLIENT, PT_BOOLEAN, "PassFirstClickToClient",
      _("Pass First Click To Client"), _("Pass focusing click on client area to client"),
      { true }, 0, 0 },
    { FOCUS_ONMAP, PT_BOOLEAN, "FocusOnMap",
      _("Focus On Map"), _("Focus normal window when initially mapped"),
      { true }, 0, 0 },
    { FOCUS_ONMAP_TRANSIENT, PT_BOOLEAN, "FocusOnMapTransient",
      _("Focus On Map Transient"), _("Focus dialog window when initially mapped"),
      { true }, 0, 0 },
    { FOCUS_ONMAP_TRANSIENT_ACTIVE, PT_BOOLEAN, "FocusOnMapTransientActive",
      _("Focus On Map Transient Active"), _("Focus dialog window when initially mapped only if parent frame focused"),
      { true }, 0, 0 },
    { POINTER_COLORMAP, PT_BOOLEAN, "PointerColormap",
      _("Pointer Colormap"), _("Colormap focus follows pointer"),
      { true }, 0, 0 },
    { SIZE_MAXIMIZED, PT_BOOLEAN, "SizeMaximized",
      _("Size Maximized"), _("Maximized windows can be resized"),
      { false }, 0, 0 },
    { SHOW_MOVE_SIZE_STATUS, PT_BOOLEAN, "ShowMoveSizeStatus",
      _("Show Move Size Status"), _("Show position status window during move/resize"),
      { true }, 0, 0 },
    { BEEP_ONNEW_MAIL, PT_BOOLEAN, "TaskBarMailboxStatusBeepOnNewMail",
      _("Mailbox Status Beep On New Mail"), _("Beep when new mail arrives"),
      { false }, 0, 0 },
    { WARP_POINTER, PT_BOOLEAN, "WarpPointer",
      _("Warp Pointer"), _("Move mouse when doing focusing in pointer focus mode"),
      { false }, 0, 0 },
    { OPAQUE_MOVE, PT_BOOLEAN, "OpaqueMove",
      _("Opaque Move"), _("Opaque window move"),
      { true }, 0, 0 },
    { OPAQUE_RESIZE, PT_BOOLEAN, "OpaqueResize",
      _("Opaque Resize"), _("Opaque window resize"),
      { true }, 0, 0 },
    { SHOW_TASK_BAR, PT_BOOLEAN, "ShowTaskBar",
      _("Show Task Bar"), _("Show task bar"),
      { true }, 0, 0 },
    { TASK_BAR_ATTOP, PT_BOOLEAN, "TaskBarAtTop",
      _("At Top"), _("Task bar at top of the screen"),
      { false }, 0, 0 },
    { TASK_BAR_SHOW_CLOCK, PT_BOOLEAN, "TaskBarShowClock",
      _("Show Clock"), _("Show clock on task bar"),
      { true }, 0, 0 },
    { TASK_BAR_SHOW_APM, PT_BOOLEAN, "TaskBarShowAPMStatus",
      _("Show APM Status"), _("Show APM status on task bar"),
      { false }, 0, 0 },
    { TASK_BAR_SHOW_MAILBOX_STATUS, PT_BOOLEAN, "TaskBarShowMailboxStatus",
      _("Show Mailbox Status"), _("Show mailbox status on task bar"),
      { true }, 0, 0 },
    { TASK_BAR_SHOW_START_MENU, PT_BOOLEAN, "TaskBarShowStartMenu",
      _("Show Start Menu"), _("Show 'Start' menu on task bar"),
      { true }, 0, 0 },
    { TASK_BAR_SHOW_WINDOW_LIST_MENU, PT_BOOLEAN, "TaskBarShowWindowListMenu",
      _("Show Window List Menu"), _("Show 'window list' menu on task bar"),
      { true }, 0, 0 },
    { TASK_BAR_SHOW_WORKSPACES, PT_BOOLEAN, "TaskBarShowWorkspaces",
      _("Show Workspaces"), _("Show workspace switching buttons on task bar"),
      { true }, 0, 0 },
    { TASK_BAR_SHOW_WINDOWS, PT_BOOLEAN, "TaskBarShowWindows",
      _("Show Windows"), _("Show windows on the taskbar"),
      { true }, 0, 0 },
    { TASK_BAR_SHOW_ALL_WINDOWS, PT_BOOLEAN, "TaskBarShowAllWindows",
      _("Show All Windows"), _("Show windows from all workspaces on task bar"),
      { false }, 0, 0 },
    { TASK_BAR_AUTO_HIDE, PT_BOOLEAN, "TaskBarAutoHide",
      _("Auto Hide"), _("Auto hide task bar after delay"),
      { false }, 0, 0 },
    { TASK_BAR_DOUBLE_HEIGHT, PT_BOOLEAN, "TaskBarDoubleHeight",
      _("Double Height"), _("Use double-height task bar"),
      { false }, 0, 0 },
    { TASK_BAR_SHOWCPU_STATUS, PT_BOOLEAN, "TaskBarShowCPUStatus",
      _("Show CPU Status"), _("Show CPU status on task bar (Linux & Solaris)"),
      { true }, 0, 0 },
    { TASK_BAR_SHOW_NET_STATUS, PT_BOOLEAN, "TaskBarShowNetStatus",
      _("Show Net Status"), _("Show network status on task bar (Linux only)"),
      { true }, 0, 0 },
    { TASK_BARCPU_SAMPLES, PT_INTEGER, "TaskBarCPUSamples",
      _("CPU Samples:"), _("Width of CPU Monitor"),
      { 20 }, 2, 1000 },
    { MINIMIZE_TODESKTOP, PT_BOOLEAN, "MinimizeToDesktop",
      _("Minimize To Desktop"), _("Display mini-icons on desktop for minimized windows"),
      { false }, 0, 0 },
    { PRETTY_CLOCK, PT_BOOLEAN, "TaskBarClockLeds",
      _("Clock Leds"), _("Task bar clock uses nice pixmapped LCD display"),
      { true }, 0, 0 },
    { MANUAL_PLACEMENT, PT_BOOLEAN, "ManualPlacement",
      _("Manual Placement"), _("Windows initially placed manually by user"),
      { false }, 0, 0 },
    { SMART_PLACEMENT, PT_BOOLEAN, "SmartPlacement",
      _("Smart Placement"), _("Smart window placement (minimal overlap)"),
      { true }, 0, 0 },
    { CENTER_TRANSIENTS_ONOWNER, PT_BOOLEAN, "CenterTransientsOnOwner",
      _("Center Transients On Owner"), _("Center dialogs on owner window"),
      { true }, 0, 0 },
    { MENU_MOUSE_TRACKING, PT_BOOLEAN, "MenuMouseTracking",
      _("Menu Mouse Tracking"), _("Menus track mouse even with no mouse buttons held"),
      { false }, 0, 0 },
    { AUTO_RAISE, PT_BOOLEAN, "AutoRaise",
      _("Auto Raise"), _("Auto raise windows after delay"),
      { false }, 0, 0 },
    { DELAY_POINTER_FOCUS, PT_BOOLEAN, "DelayPointerFocus",
      _("Delay Pointer Focus"), _("Delay pointer focusing when mouse moves"),
      { false }, 0, 0 },
    { USE_MOUSE_WHEEL, PT_BOOLEAN, "UseMouseWheel",
      _("Use Mouse Wheel"), _("Support mouse wheel"),
      { false }, 0, 0 },
    { QUICK_SWITCH, PT_BOOLEAN, "QuickSwitch",
      _("Quick Switch"), _("Alt+Tab window switching"),
      { true }, 0, 0 },
    { QUICK_SWITCH_TOMINIMIZED, PT_BOOLEAN, "QuickSwitchToMinimized",
      _("Quick Switch To Minimized"), _("Alt+Tab to minimized windows"),
      { true }, 0, 0 },
    { QUICK_SWITCH_TOHIDDEN, PT_BOOLEAN, "QuickSwitchToHidden",
      _("Quick Switch To Hidden"), _("Alt+Tab to hidden windows"),
      { false }, 0, 0 },
    { QUICK_SWITCH_TOALL_WORKSPACES, PT_BOOLEAN, "QuickSwitchToAllWorkspaces",
      _("Quick Switch To All Workspaces"), _("Alt+Tab to windows on other workspaces"),
      { false }, 0, 0 },
    { COUNT_MAIL_MESSAGES, PT_BOOLEAN, "TaskBarMailboxStatusCountMessages",
      _("Mailbox Status Count Messages"), _("Count messages in mailbox"),
      { false }, 0, 0 },
    { STRONG_POINTER_FOCUS, PT_BOOLEAN, "StrongPointerFocus",
      _("Strong Pointer Focus"), _("Always maintain focus under mouse window (makes some keyboard support non-functional or unreliable"),
      { false }, 0, 0 },
    { GRAB_ROOT_WINDOW, PT_BOOLEAN, "GrabRootWindow",
      _("Grab Root Window"), _("Manage root window (EXPERIMENTAL - normally enabled!)"),
      { true }, 0, 0 },
    { SNAP_MOVE, PT_BOOLEAN, "SnapMove",
      _("Snap Move"), _("Snap to nearest screen edge/window when moving windows"),
      { true }, 0, 0 },
    { CENTER_BACKGROUND, PT_BOOLEAN, "DesktopBackgroundCenter",
      _("Desktop Background Center"), _("Display desktop background centered and not tiled"),
      { false }, 0, 0 },
    { EDGE_WORKSPACE_SWITCHING, PT_BOOLEAN, "EdgeSwitch",
      _("Edge Switch"), _("Workspace switches by moving mouse to left/right screen edge"),
      { false }, 0, 0 },
    { SHOW_POPUPS_ABOVE_POINTER, PT_BOOLEAN, "ShowPopupsAbovePointer",
      _("Show Popups Above Pointer"), _("Show popup menus above mouse pointer"),
      { false }, 0, 0 },
    { REPLAY_MENU_CANCEL_CLICK, PT_BOOLEAN, "ReplayMenuCancelClick",
      _("Replay Menu Cancel Click"), _("Send the clicks outside menus to target window"),
      { false }, 0, 0 },
    { LIMIT_SIZE, PT_BOOLEAN, "LimitSize",
      _("Limit Size"), _("Limit initial size of windows to screen"),
      { true }, 0, 0 },
    { LIMIT_POSITION, PT_BOOLEAN, "LimitPosition",
      _("Limit Position"), _("Limit initial position of windows to screen"),
      { true }, 0, 0 },
    { WIN95KEYS, PT_BOOLEAN, "Win95Keys",
      _("Win95 Keys"), _("Support win95 keyboard keys (Penguin/Meta/Win_L,R shows menu)"),
      { false }, 0, 0 },
    { MOD_META_ISCTRL_ALT, PT_BOOLEAN, "ModMetaIsCtrlAlt",
      _("ModMeta Is CtrlAlt"), _("Treat Penguin/Meta/Win modifier as Ctrl+Alt"),
      { true }, 0, 0 },
    { AUTO_RELOAD_MENUS, PT_BOOLEAN, "AutoReloadMenus",
      _("Auto Reload Menus"), _("Reload menu files automatically"),
      { true }, 0, 0 },
    { SHOW_FRAME_ICON, PT_BOOLEAN, "ShowMenuButtonIcon",
      _("Show Menu Button Icon"), _("Show application icon over menu button"),
      { true }, 0, 0 },
    { AUTO_DETECT_GNOME, PT_BOOLEAN, "AutoDetectGNOME",
      _("Auto Detect GNOME"), _("Automatically disable some functionality when running under GNOME."),
      { true }, 0, 0 },
    { CLIENT_MOUSE_ACTIONS, PT_BOOLEAN, "ClientWindowMouseActions",
      _("Client Window Mouse Actions"), _("Allow mouse actions on client windows (buggy with some programs)"),
      { true }, 0, 0 },
    { TITLE_BAR_CENTERED, PT_BOOLEAN, "TitleBarCentered",
      _("Title Bar Centered"), _("Draw window title centered"),
      { false }, 0, 0 },
    { SHOW_THEMES_MENU, PT_BOOLEAN, "ShowThemesMenu",
      _("Show Themes Menu"), _("Show themes submenu"),
      { true }, 0, 0 },
    { CONFIRM_LOGOUT, PT_BOOLEAN, "ConfirmLogout",
      _("Confirm Logout"), _("Confirm logout"),
      { true }, 0, 0 },
    { WS_BORDERX, PT_INTEGER, "BorderSizeX",
      _("Border Size X:"), _("Horizontal window border"),
      { 6 }, 0, 128 },
    { WS_BORDERY, PT_INTEGER, "BorderSizeY",
      _("Border Size Y:"), _("Vertical window border"),
      { 6 }, 0, 128 },
    { WS_DLG_BORDERX, PT_INTEGER, "DlgBorderSizeX",
      _("Dialog Border Size X:"), _("Horizontal dialog window border"),
      { 2 }, 0, 128 },
    { WS_DLG_BORDERY, PT_INTEGER, "DlgBorderSizeY",
      _("Dialog Border Size Y:"), _("Vertical dialog window border"),
      { 2 }, 0, 128 },
    { WS_TITLE_BAR, PT_INTEGER, "TitleBarHeight",
      _("Title Bar Height:"), _("Title bar height"),
      { 20 }, 0, 128 },
    { WS_CORNERX, PT_INTEGER, "CornerSizeX",
      _("Corner Size X:"), _("Resize corner width"),
      { 24 }, 0, 64 },
    { WS_CORNERY, PT_INTEGER, "CornerSizeY",
      _("Corner Size Y:"), _("Resize corner height"),
      { 24 }, 0, 64 },
    { CLICK_MOTION_DISTANCE, PT_INTEGER, "ClickMotionDistance",
      _("Click Motion Distance:"), _("Pointer motion distance before click gets interpreted as drag"),
      { 4 }, 0, 32 },
    { CLICK_MOTION_DELAY, PT_INTEGER, "ClickMotionDelay",
      _("Click Motion Delay:"), _("Delay before click gets interpreted as drag"),
      { 200 }, 0, 2000 },
    { MULTI_CLICK_TIME, PT_INTEGER, "MultiClickTime",
      _("MultiClick Time:"), _("Multiple click time"),
      { 400 }, 0, 5000 },
    { TOOL_TIP_DELAY, PT_INTEGER, "ToolTipDelay",
      _("Tool Tip Delay:"), _("Delay before tooltip window is displayed"),
      { 1000 }, 0, 5000 },
    { TOOL_TIP_TIME, PT_INTEGER, "ToolTipTime",
      _("Tool Tip Time:"), _("Time before tooltip window is hidden"),
      { 5000 }, 0, 60000 },
    { MENU_ACTIVATE_DELAY, PT_INTEGER, "MenuActivateDelay",
      _("Menu Activate Delay:"), _("Delay before activating menu items"),
      { 10 }, 0, 5000 },
    { SUBMENU_ACTIVATE_DELAY, PT_INTEGER, "SubmenuMenuActivateDelay",
      _("Submenu Menu Activate Delay:"), _("Delay before activating menu submenus"),
      { 300 }, 0, 5000 },
    { EDGE_RESISTANCE, PT_INTEGER, "EdgeResistance",
      _("Edge Resistance:"), _("Resistance in pixels when trying to move windows off the screen (10000 = infinite)"),
      { 32 }, 0, 10000 },
    { SNAP_DISTANCE, PT_INTEGER, "SnapDistance",
      _("Snap Distance:"), _("Distance in pixels before windows snap together"),
      { 8 }, 0, 64 },
    { POINTER_FOCUS_DELAY, PT_INTEGER, "PointerFocusDelay",
      _("Pointer Focus Delay:"), _("Delay for pointer focus switching"),
      { 200 }, 0, 1000 },
    { AUTO_RAISE_DELAY, PT_INTEGER, "AutoRaiseDelay",
      _("Auto Raise Delay:"), _("Delay before windows are auto raised"),
      { 400 }, 0, 5000 },
    { AUTO_HIDE_DELAY, PT_INTEGER, "AutoHideDelay",
      _("Auto Hide Delay:"), _("Delay before task bar is automatically hidden"),
      { 300 }, 0, 5000 },
    { EDGE_SWITCH_DELAY, PT_INTEGER, "EdgeSwitchDelay",
      _("Edge Switch Delay:"), _("Screen edge workspace switching delay"),
      { 600 }, 0, 5000 },
    { SCROLL_BAR_START_DELAY, PT_INTEGER, "ScrollBarStartDelay",
      _("Scroll Bar Start Delay:"), _("Inital scroll bar autoscroll delay"),
      { 500 }, 0, 5000 },
    { SCROLL_BAR_DELAY, PT_INTEGER, "ScrollBarDelay",
      _("Scroll Bar Delay:"), _("Scroll bar autoscroll delay"),
      { 30 }, 0, 5000 },
    { AUTO_SCROLL_START_DELAY, PT_INTEGER, "AutoScrollStartDelay",
      _("Auto Scroll Start Delay:"), _("Auto scroll start delay"),
      { 500 }, 0, 5000 },
    { AUTO_SCROLL_DELAY, PT_INTEGER, "AutoScrollDelay",
      _("Auto Scroll Delay:"), _("Auto scroll delay"),
      { 60 }, 0, 5000 },
    { USE_ROOT_BUTTONS, PT_INTEGER, "UseRootButtons",
      _("Use Root Buttons:"), _("Bitmask of root window button click to use in window manager"),
      { 255 }, 0, 255 },
    { BUTTON_RAISE_MASK, PT_INTEGER, "ButtonRaiseMask",
      _("Button Raise Mask:"), _("Bitmask of buttons that raise the window when pressed"),
      { 1 }, 0, 255 },
    { ROOT_WIN_MENU_BUTTON, PT_INTEGER, "DesktopWinMenuButton",
      _("Desktop Window Menu Button:"), _("Desktop mouse-button click to show the menu"),
      { 1 }, 0, 20 },
    { ROOT_WIN_LIST_BUTTON, PT_INTEGER, "DesktopWinListButton",
      _("Desktop Window List Button:"), _("Desktop mouse-button click to show the window list"),
      { 2 }, 0, 5 },
    { ROOT_MENU_BUTTON, PT_INTEGER, "DesktopMenuButton",
      _("Desktop Menu Button:"), _("Desktop mouse-button click to show the window list menu"),
      { 3 }, 0, 20 },
    { TITLE_MAXIMIZE_BUTTON, PT_INTEGER, "TitleBarMaximizeButton",
      _("Title Bar Maximize Button:"), _("TitleBar mouse-button double click to maximize the window"),
      { 1 }, 0, 5 },
    { TITLE_ROLLUP_BUTTON, PT_INTEGER, "TitleBarRollupButton",
      _("Title Bar Rollup Button:"), _("TitleBar mouse-button double clock to rollup the window"),
      { 2 }, 0, 5 },
    { MAIL_CHECK_DELAY, PT_INTEGER, "MailCheckDelay",
      _("Mail Check Delay:"), _("Delay between new-mail checks. (seconds)"),
      { 30 }, 0, (3600*24) },
    { TITLE_BUTTONS_LEFT, PT_STRING, "TitleButtonsLeft",
      _("Title Buttons Left:"), _("Titlebar buttons from left to right (x=close, m=max, i=min, h=hide, r=rollup, s=sysmenu, d=depth)"),
      { (int) "s" }, 0, 0 },
    { TITLE_BUTTONS_RIGHT, PT_STRING, "TitleButtonsRight",
      _("Title Buttons Right:"), _("Titlebar buttons from right to left (x=close, m=max, i=min, h=hide, r=rollup, s=sysmenu, d=depth)"),
      { (int) "xmir" }, 0, 0 },
    { TITLE_BUTTONS_SUPPORTED, PT_STRING, "TitleButtonsSupported",
      _("Title Buttons Supported:"), _("Titlebar buttons supported by theme (x,m,i,r,h,s,d)"),
      { (int) "xmis" }, 0, 0 },
    { THEME_NAME, PT_STRING, "Theme",
      _("Theme:"), _("Theme"),
      { (int) "warp3/default.theme" }, 0, 0 },
    { THEME_AUTHOR, PT_STRING, "ThemeAuthor",
      _("Theme Author:"), _("Theme Author"),
      { (int) 0 }, 0, 0 },
    { THEME_DESCRIPTION, PT_STRING, "ThemeDescription",
      _("Theme Description:"), _("Theme Description"),
      { (int) 0 }, 0, 0 },
    { TITLE_FONT_NAME, PT_STRING, "TitleFontName",
      _("Title:"), _(""),
      { (int) "-b&h-lucida-bold-r-*-*-*-120-*-*-*-*-*-*" }, 0, 0 },
    { MENU_FONT_NAME, PT_STRING, "MenuFontName",
      _("Menu:"), _(""),
      { (int) "-b&h-lucida-bold-r-*-*-*-120-*-*-*-*-*-*" }, 0, 0 },
    { STATUS_FONT_NAME, PT_STRING, "StatusFontName",
      _("Status:"), _(""),
      { (int) "-b&h-lucidatypewriter-bold-r-*-*-*-120-*-*-*-*-*-*" }, 0, 0 },
    { SWITCH_FONT_NAME, PT_STRING, "QuickSwitchFontName",
      _("Quick Switch:"), _(""),
      { (int) "-b&h-lucidatypewriter-bold-r-*-*-*-120-*-*-*-*-*-*" }, 0, 0 },
    { NORMAL_BUTTON_FONT_NAME, PT_STRING, "NormalButtonFontName",
      _("Normal Button:"), _(""),
      { (int) "-b&h-lucida-medium-r-*-*-*-120-*-*-*-*-*-*" }, 0, 0 },
    { ACTIVE_BUTTON_FONT_NAME, PT_STRING, "ActiveButtonFontName",
      _("Active Button:"), _(""),
      { (int) "-b&h-lucida-bold-r-*-*-*-120-*-*-*-*-*-*" }, 0, 0 },
    { NORMAL_TASK_BAR_FONT_NAME, PT_STRING, "NormalTaskBarFontName",
      _("Normal Task Bar:"), _(""),
      { (int) "-b&h-lucida-medium-r-*-*-*-120-*-*-*-*-*-*" }, 0, 0 },
    { ACTIVE_TASK_BAR_FONT_NAME, PT_STRING, "ActiveTaskBarFontName",
      _("Active Task Bar:"), _(""),
      { (int) "-b&h-lucida-bold-r-*-*-*-120-*-*-*-*-*-*" }, 0, 0 },
    { MINIMIZED_WINDOW_FONT_NAME, PT_STRING, "MinimizedWindowFontName",
      _("Minimized Window:"), _(""),
      { (int) "-b&h-lucida-medium-r-*-*-*-120-*-*-*-*-*-*" }, 0, 0 },
    { LIST_BOX_FONT_NAME, PT_STRING, "ListBoxFontName",
      _("List Box:"), _(""),
      { (int) "-b&h-lucida-medium-r-*-*-*-120-*-*-*-*-*-*" }, 0, 0 },
    { TOOL_TIP_FONT_NAME, PT_STRING, "ToolTipFontName",
      _("Tool Tip:"), _(""),
      { (int) "-b&h-lucida-medium-r-*-*-*-120-*-*-*-*-*-*" }, 0, 0 },
    { LABEL_FONT_NAME, PT_STRING, "LabelFontName",
      _("Label:"), _(""),
      { (int) "-b&h-lucida-medium-r-*-*-*-140-*-*-*-*-*-*" }, 0, 0 },
    { CLOCK_FONT_NAME, PT_STRING, "ClockFontName",
      _("Clock:"), _(""),
      { (int) "-b&h-lucidatypewriter-medium-r-*-*-*-140-*-*-*-*-*-*" }, 0, 0 },
    { APM_FONT_NAME, PT_STRING, "ApmFontName",
      _("APM:"), _(""),
      { (int) "-b&h-lucidatypewriter-medium-r-*-*-*-140-*-*-*-*-*-*" }, 0, 0 },
    { ICON_PATH, PT_STRING, "IconPath",
      _("Icon Path:"), _("Icon search path (colon separated)"),
      { (int) 0 }, 0, 0 },
    { MAIL_BOX_PATH, PT_STRING, "MailBoxPath",
      _("Mail Box Path:"), _("Mailbox path (use $MAIL instead)"),
      { (int) 0 }, 0, 0 },
    { MAIL_COMMAND, PT_STRING, "MailCommand",
      _("Mail:"), _("Command to run on mailbox"),
      { (int) 0 }, 0, 0 },
    { NEW_MAIL_COMMAND, PT_STRING, "NewMailCommand",
      _("New Mail:"), _("Command to run when new mail arrives"),
      { (int) 0 }, 0, 0 },
    { LOCK_COMMAND, PT_STRING, "LockCommand",
      _("Lock:"), _("Command to lock display/screensaver"),
      { (int) "xlock" }, 0, 0 },
    { CLOCK_COMMAND, PT_STRING, "ClockCommand",
      _("Clock:"), _("Command to run on clock"),
      { (int) "xclock" }, 0, 0 },
    { RUN_DLG_COMMAND, PT_STRING, "RunCommand",
      _("Run:"), _("Command to select and run a program"),
      { (int) 0 }, 0, 0 },
    { OPEN_COMMAND, PT_STRING, "OpenCommand",
      _("Open:"), _(""),
      { (int) 0 }, 0, 0 },
    { TERMINAL_COMMAND, PT_STRING, "TerminalCommand",
      _("Terminal:"), _("Terminal emulator must accept -e option."),
      { (int) "xterm" }, 0, 0 },
    { LOGOUT_COMMAND, PT_STRING, "LogoutCommand",
      _("Logout:"), _("Command to start logout"),
      { (int) 0 }, 0, 0 },
    { LOGOUT_CANCEL_COMMAND, PT_STRING, "LogoutCancelCommand",
      _("Logout Cancel:"), _("Command to cancel logout"),
      { (int) 0 }, 0, 0 },
    { SHUTDOWN_COMMAND, PT_STRING, "ShutdownCommand",
      _("Shutdown:"), _("Command to shutdown the system"),
      { (int) "shutdown -h now" }, 0, 0 },
    { REBOOT_COMMAND, PT_STRING, "RebootCommand",
      _("Reboot:"), _("Command to reboot the system"),
      { (int) "shutdown -r now" }, 0, 0 },
    { NET_DEVICE, PT_STRING, "NetworkStatusDevice",
      _("Network Status Device:"), _("Network device to show status for"),
      { (int) "ppp0" }, 0, 0 },
    { CPU_COMMAND, PT_STRING, "CPUStatusCommand",
      _("CPU Status:"), _("Command to run on CPU status"),
      { (int) 0 }, 0, 0 },
    { NET_COMMAND, PT_STRING, "NetStatusCommand",
      _("Net Status:"), _("Command to run on Net status"),
      { (int) 0 }, 0, 0 },
    { ADDRESS_BAR_COMMAND, PT_STRING, "AddressBarCommand",
      _("Address Bar:"), _("Command to run for address bar entries"),
      { (int) 0 }, 0, 0 },
    { FMT_TIME, PT_STRING, "TimeFormat",
      _("Time Format:"), _("Clock Time format (strftime format string)"),
      { (int) "%H:%M:%S" }, 0, 0 },
    { FMT_DATE, PT_STRING, "DateFormat",
      _("Date Format:"), _("Clock Date format for tooltip (strftime format string)"),
      { (int) "%B %A %Y-%m-%d %H:%M:%S %Z" }, 0, 0 },
    { CLR_DIALOG, PT_STRING, "ColorDialog",
      _("Dialog:"), _(""),
      { (int) "rgb:C0/C0/C0" }, 0, 0 },
    { CLR_ACTIVE_BORDER, PT_STRING, "ColorActiveBorder",
      _("Active Border:"), _(""),
      { (int) "rgb:C0/C0/C0" }, 0, 0 },
    { CLR_INACTIVE_BORDER, PT_STRING, "ColorNormalBorder",
      _("Normal Border:"), _(""),
      { (int) "rgb:C0/C0/C0" }, 0, 0 },
    { CLR_NORMAL_TITLE_BUTTON, PT_STRING, "ColorNormalTitleButton",
      _("Normal Title Button:"), _(""),
      { (int) "rgb:C0/C0/C0" }, 0, 0 },
    { CLR_NORMAL_TITLE_BUTTON_TEXT, PT_STRING, "ColorNormalTitleButtonText",
      _("Normal Title Button Text:"), _(""),
      { (int) "rgb:00/00/00" }, 0, 0 },
    { CLR_ACTIVE_TITLE_BAR, PT_STRING, "ColorActiveTitleBar",
      _("Active Title Bar:"), _(""),
      { (int) "rgb:00/00/A0" }, 0, 0 },
    { CLR_INACTIVE_TITLE_BAR, PT_STRING, "ColorNormalTitleBar",
      _("Normal Title Bar:"), _(""),
      { (int) "rgb:80/80/80" }, 0, 0 },
    { CLR_ACTIVE_TITLE_BAR_TEXT, PT_STRING, "ColorActiveTitleBarText",
      _("Active Title Bar Text:"), _(""),
      { (int) "rgb:FF/FF/FF" }, 0, 0 },
    { CLR_INACTIVE_TITLE_BAR_TEXT, PT_STRING, "ColorNormalTitleBarText",
      _("Normal Title Bar Text:"), _(""),
      { (int) "rgb:00/00/00" }, 0, 0 },
    { CLR_NORMAL_MINIMIZED_WINDOW, PT_STRING, "ColorNormalMinimizedWindow",
      _("Normal Minimized Window:"), _(""),
      { (int) "rgb:C0/C0/C0" }, 0, 0 },
    { CLR_NORMAL_MINIMIZED_WINDOW_TEXT, PT_STRING, "ColorNormalMinimizedWindowText",
      _("Normal Minimized Window Text:"), _(""),
      { (int) "rgb:00/00/00" }, 0, 0 },
    { CLR_ACTIVE_MINIMIZED_WINDOW, PT_STRING, "ColorActiveMinimizedWindow",
      _("Active Minimized Window:"), _(""),
      { (int) "rgb:E0/E0/E0" }, 0, 0 },
    { CLR_ACTIVE_MINIMIZED_WINDOW_TEXT, PT_STRING, "ColorActiveMinimizedWindowText",
      _("Active Minimized Window Text:"), _(""),
      { (int) "rgb:00/00/00" }, 0, 0 },
    { CLR_NORMAL_MENU, PT_STRING, "ColorNormalMenu",
      _("Normal Menu:"), _(""),
      { (int) "rgb:C0/C0/C0" }, 0, 0 },
    { CLR_ACTIVE_MENU_ITEM, PT_STRING, "ColorActiveMenuItem",
      _("Active Menu Item:"), _(""),
      { (int) "rgb:A0/A0/A0" }, 0, 0 },
    { CLR_ACTIVE_MENU_ITEM_TEXT, PT_STRING, "ColorActiveMenuItemText",
      _("Active Menu Item Text:"), _(""),
      { (int) "rgb:00/00/00" }, 0, 0 },
    { CLR_NORMAL_MENU_ITEM_TEXT, PT_STRING, "ColorNormalMenuItemText",
      _("Normal Menu Item Text:"), _(""),
      { (int) "rgb:00/00/00" }, 0, 0 },
    { CLR_DISABLED_MENU_ITEM_TEXT, PT_STRING, "ColorDisabledMenuItemText",
      _("Disabled Menu Item Text:"), _(""),
      { (int) "rgb:80/80/80" }, 0, 0 },
    { CLR_MOVE_SIZE_STATUS, PT_STRING, "ColorMoveSizeStatus",
      _("Move Size Status:"), _(""),
      { (int) "rgb:C0/C0/C0" }, 0, 0 },
    { CLR_MOVE_SIZE_STATUS_TEXT, PT_STRING, "ColorMoveSizeStatusText",
      _("Move Size Status Text:"), _(""),
      { (int) "rgb:00/00/00" }, 0, 0 },
    { CLR_QUICK_SWITCH, PT_STRING, "ColorQuickSwitch",
      _("Quick Switch:"), _(""),
      { (int) "rgb:C0/C0/C0" }, 0, 0 },
    { CLR_QUICK_SWITCH_TEXT, PT_STRING, "ColorQuickSwitchText",
      _("Quick Switch Text:"), _(""),
      { (int) "rgb:00/00/00" }, 0, 0 },
    { CLR_DEFAULT_TASK_BAR, PT_STRING, "ColorDefaultTaskBar",
      _("Default Task Bar:"), _(""),
      { (int) "rgb:C0/C0/C0" }, 0, 0 },
    { CLR_NORMAL_BUTTON, PT_STRING, "ColorNormalButton",
      _("Normal Button:"), _(""),
      { (int) "rgb:C0/C0/C0" }, 0, 0 },
    { CLR_NORMAL_BUTTON_TEXT, PT_STRING, "ColorNormalButtonText",
      _("Normal Button Text:"), _(""),
      { (int) "rgb:00/00/00" }, 0, 0 },
    { CLR_ACTIVE_BUTTON, PT_STRING, "ColorActiveButton",
      _("Active Button:"), _(""),
      { (int) "rgb:E0/E0/E0" }, 0, 0 },
    { CLR_ACTIVE_BUTTON_TEXT, PT_STRING, "ColorActiveButtonText",
      _("Active Button Text:"), _(""),
      { (int) "rgb:00/00/00" }, 0, 0 },
    { CLR_NORMAL_TASK_BAR_APP, PT_STRING, "ColorNormalTaskBarApp",
      _("Normal Task Bar App:"), _(""),
      { (int) "rgb:C0/C0/C0" }, 0, 0 },
    { CLR_NORMAL_TASK_BAR_APP_TEXT, PT_STRING, "ColorNormalTaskBarAppText",
      _("Normal Task Bar App Text:"), _(""),
      { (int) "rgb:00/00/00" }, 0, 0 },
    { CLR_ACTIVE_TASK_BAR_APP, PT_STRING, "ColorActiveTaskBarApp",
      _("Active Task Bar App:"), _(""),
      { (int) "rgb:E0/E0/E0" }, 0, 0 },
    { CLR_ACTIVE_TASK_BAR_APP_TEXT, PT_STRING, "ColorActiveTaskBarAppText",
      _("Active Task Bar App Text:"), _(""),
      { (int) "rgb:00/00/00" }, 0, 0 },
    { CLR_MINIMIZED_TASK_BAR_APP, PT_STRING, "ColorMinimizedTaskBarApp",
      _("Minimized Task Bar App:"), _(""),
      { (int) "rgb:A0/A0/A0" }, 0, 0 },
    { CLR_MINIMIZED_TASK_BAR_APP_TEXT, PT_STRING, "ColorMinimizedTaskBarAppText",
      _("Minimized Task Bar App Text:"), _(""),
      { (int) "rgb:00/00/00" }, 0, 0 },
    { CLR_INVISIBLE_TASK_BAR_APP, PT_STRING, "ColorInvisibleTaskBarApp",
      _("Invisible Task Bar App:"), _("Color for windows on other workspaces"),
      { (int) "rgb:80/80/80" }, 0, 0 },
    { CLR_INVISIBLE_TASK_BAR_APP_TEXT, PT_STRING, "ColorInvisibleTaskBarAppText",
      _("Invisible Task Bar App Text:"), _(""),
      { (int) "rgb:00/00/00" }, 0, 0 },
    { CLR_SCROLL_BAR, PT_STRING, "ColorScrollBar",
      _("Scroll Bar:"), _(""),
      { (int) "rgb:A0/A0/A0" }, 0, 0 },
    { CLR_SCROLL_BAR_ARROW, PT_STRING, "ColorScrollBarArrow",
      _("Scroll Bar Arrow:"), _(""),
      { (int) "rgb:C0/C0/C0" }, 0, 0 },
    { CLR_SCROLL_BAR_SLIDER, PT_STRING, "ColorScrollBarSlider",
      _("Scroll Bar Slider:"), _(""),
      { (int) "rgb:C0/C0/C0" }, 0, 0 },
    { CLR_LIST_BOX, PT_STRING, "ColorListBox",
      _("List Box:"), _(""),
      { (int) "rgb:C0/C0/C0" }, 0, 0 },
    { CLR_LIST_BOX_TEXT, PT_STRING, "ColorListBoxText",
      _("List Box Text:"), _(""),
      { (int) "rgb:00/00/00" }, 0, 0 },
    { CLR_LIST_BOX_SELECTED, PT_STRING, "ColorListBoxSelection",
      _("List Box Selection:"), _(""),
      { (int) "rgb:80/80/80" }, 0, 0 },
    { CLR_LIST_BOX_SELECTED_TEXT, PT_STRING, "ColorListBoxSelectionText",
      _("List Box Selection Text:"), _(""),
      { (int) "rgb:00/00/00" }, 0, 0 },
    { CLR_TOOL_TIP, PT_STRING, "ColorToolTip",
      _("Tool Tip:"), _(""),
      { (int) "rgb:E0/E0/00" }, 0, 0 },
    { CLR_TOOL_TIP_TEXT, PT_STRING, "ColorToolTipText",
      _("Tool Tip Text:"), _(""),
      { (int) "rgb:00/00/00" }, 0, 0 },
    { CLR_CLOCK, PT_STRING, "ColorClock",
      _("Clock:"), _(""),
      { (int) "rgb:00/00/00" }, 0, 0 },
    { CLR_CLOCK_TEXT, PT_STRING, "ColorClockText",
      _("Clock Text:"), _(""),
      { (int) "rgb:00/FF/00" }, 0, 0 },
    { CLR_APM, PT_STRING, "ColorApm",
      _("APM:"), _(""),
      { (int) "rgb:00/00/00" }, 0, 0 },
    { CLR_APM_TEXT, PT_STRING, "ColorApmText",
      _("APM Text:"), _(""),
      { (int) "rgb:00/FF/00" }, 0, 0 },
    { CLR_INPUT, PT_STRING, "ColorInput",
      _("Input:"), _(""),
      { (int) "rgb:FF/FF/FF" }, 0, 0 },
    { CLR_INPUT_TEXT, PT_STRING, "ColorInputText",
      _("Input Text:"), _(""),
      { (int) "rgb:00/00/00" }, 0, 0 },
    { CLR_INPUT_SELECTION, PT_STRING, "ColorInputSelection",
      _("Input Selection:"), _(""),
      { (int) "rgb:80/80/80" }, 0, 0 },
    { CLR_INPUT_SELECTION_TEXT, PT_STRING, "ColorInputSelectionText",
      _("Input Selection Text:"), _(""),
      { (int) "rgb:00/00/00" }, 0, 0 },
    { CLR_LABEL, PT_STRING, "ColorLabel",
      _("Label:"), _(""),
      { (int) "rgb:C0/C0/C0" }, 0, 0 },
    { CLR_LABEL_TEXT, PT_STRING, "ColorLabelText",
      _("Label Text:"), _(""),
      { (int) "rgb:00/00/00" }, 0, 0 },
    { CLR_CPU_USER, PT_STRING, "ColorCPUStatusUser",
      _("CPU Status User:"), _(""),
      { (int) "rgb:00/FF/00" }, 0, 0 },
    { CLR_CPU_SYS, PT_STRING, "ColorCPUStatusSystem",
      _("CPU Status System:"), _(""),
      { (int) "rgb:FF/00/00" }, 0, 0 },
    { CLR_CPU_NICE, PT_STRING, "ColorCPUStatusNice",
      _("CPU Status Nice:"), _(""),
      { (int) "rgb:00/00/FF" }, 0, 0 },
    { CLR_CPU_IDLE, PT_STRING, "ColorCPUStatusIdle",
      _("CPU Status Idle:"), _(""),
      { (int) "rgb:00/00/00" }, 0, 0 },
    { CLR_NET_SEND, PT_STRING, "ColorNetSend",
      _("Net Send:"), _(""),
      { (int) "rgb:FF/FF/00" }, 0, 0 },
    { CLR_NET_RECEIVE, PT_STRING, "ColorNetReceive",
      _("Net Receive:"), _(""),
      { (int) "rgb:FF/00/FF" }, 0, 0 },
    { CLR_NET_IDLE, PT_STRING, "ColorNetIdle",
      _("Net Idle:"), _(""),
      { (int) "rgb:00/00/00" }, 0, 0 },
    { DESKTOP_BACKGROUND_COLOR, PT_STRING, "DesktopBackgroundColor",
      _("Desktop Background Color:"), _(""),
      { (int) "rgb:00/50/60" }, 0, 0 },
    { DESKTOP_BACKGROUND_PIXMAP, PT_STRING, "DesktopBackgroundImage",
      _("Desktop Background Image:"), _(""),
      { (int) 0 }, 0, 0 },
    { KEY_WIN_RAISE, PT_STRING, "KeyWinRaise",
      _("Window Raise:"), _(""),
      { (int) "Alt+F1" }, 4 , GDK_F1 },
    { KEY_WIN_OCCUPY_ALL, PT_STRING, "KeyWinOccupyAll",
      _("Window Occupy All:"), _(""),
      { (int) "Alt+F2" }, 4 , GDK_F2 },
    { KEY_WIN_LOWER, PT_STRING, "KeyWinLower",
      _("Window Lower:"), _(""),
      { (int) "Alt+F3" }, 4 , GDK_F3 },
    { KEY_WIN_CLOSE, PT_STRING, "KeyWinClose",
      _("Window Close:"), _(""),
      { (int) "Alt+F4" }, 4 , GDK_F4 },
    { KEY_WIN_RESTORE, PT_STRING, "KeyWinRestore",
      _("Window Restore:"), _(""),
      { (int) "Alt+F5" }, 4 , GDK_F5 },
    { KEY_WIN_PREV, PT_STRING, "KeyWinPrev",
      _("Window Prev:"), _(""),
      { (int) "Alt+Shift+F6" }, 4 + 1 , GDK_F6 },
    { KEY_WIN_NEXT, PT_STRING, "KeyWinNext",
      _("Window Next:"), _(""),
      { (int) "Alt+F6" }, 4 , GDK_F6 },
    { KEY_WIN_MOVE, PT_STRING, "KeyWinMove",
      _("Window Move:"), _(""),
      { (int) "Alt+F7" }, 4 , GDK_F7 },
    { KEY_WIN_SIZE, PT_STRING, "KeyWinSize",
      _("Window Size:"), _(""),
      { (int) "Alt+F8" }, 4 , GDK_F8 },
    { KEY_WIN_MINIMIZE, PT_STRING, "KeyWinMinimize",
      _("Window Minimize:"), _(""),
      { (int) "Alt+F9" }, 4 , GDK_F9 },
    { KEY_WIN_MAXIMIZE, PT_STRING, "KeyWinMaximize",
      _("Window Maximize:"), _(""),
      { (int) "Alt+F10" }, 4 , GDK_F10 },
    { KEY_WIN_MAXIMIZE_VERT, PT_STRING, "KeyWinMaximizeVert",
      _("Window Maximize Vert:"), _(""),
      { (int) "Alt+Shift+F10" }, 4 + 1 , GDK_F10 },
    { KEY_WIN_HIDE, PT_STRING, "KeyWinHide",
      _("Window Hide:"), _(""),
      { (int) "Alt+F11" }, 4 , GDK_F11 },
    { KEY_WIN_ROLLUP, PT_STRING, "KeyWinRollup",
      _("Window Rollup:"), _(""),
      { (int) "Alt+F12" }, 4 , GDK_F12 },
    { KEY_WIN_MENU, PT_STRING, "KeyWinMenu",
      _("Window Menu:"), _(""),
      { (int) "Alt+Space" }, 4 , ' ' },
    { KEY_SYS_SWITCH_NEXT, PT_STRING, "KeySysSwitchNext",
      _("Sys Switch Next:"), _(""),
      { (int) "Alt+Tab" }, 4 , GDK_Tab },
    { KEY_SYS_SWITCH_LAST, PT_STRING, "KeySysSwitchLast",
      _("Sys Switch Last:"), _(""),
      { (int) "Alt+Shift+Tab" }, 4 + 1 , GDK_Tab },
    { KEY_SYS_WIN_NEXT, PT_STRING, "KeySysWinNext",
      _("Sys Window Next:"), _(""),
      { (int) "Alt+Esc" }, 4 , GDK_Escape },
    { KEY_SYS_WIN_PREV, PT_STRING, "KeySysWinPrev",
      _("Sys Window Prev:"), _(""),
      { (int) "Alt+Shift+Esc" }, 4 + 1 , GDK_Escape },
    { KEY_SYS_WIN_MENU, PT_STRING, "KeySysWinMenu",
      _("Sys Window Menu:"), _(""),
      { (int) "Shift+Esc" }, 1 , GDK_Escape },
    { KEY_SYS_DIALOG, PT_STRING, "KeySysDialog",
      _("Sys Dialog:"), _(""),
      { (int) "Alt+Ctrl+Del" }, 4 + 2 , GDK_Delete },
    { KEY_SYS_MENU, PT_STRING, "KeySysMenu",
      _("Sys Menu:"), _(""),
      { (int) "Ctrl+Esc" }, 2 , GDK_Escape },
    { KEY_SYS_RUN, PT_STRING, "KeySysRun",
      _("Sys Run:"), _(""),
      { (int) "Alt+Ctrl+r" }, 4 + 2 , 'r' },
    { KEY_SYS_WINDOW_LIST, PT_STRING, "KeySysWindowList",
      _("Sys Window List:"), _(""),
      { (int) "Alt+Ctrl+Esc" }, 2 + 4 , GDK_Escape },
    { KEY_SYS_ADDRESS_BAR, PT_STRING, "KeySysAddressBar",
      _("Sys Address Bar:"), _(""),
      { (int) "Alt+Ctrl+Space" }, 4 + 2 , ' ' },
    { KEY_SYS_WORKSPACE_PREV, PT_STRING, "KeySysWorkspacePrev",
      _("Sys Workspace Prev:"), _(""),
      { (int) "Alt+Ctrl+Left" }, 4 + 2 , GDK_Left },
    { KEY_SYS_WORKSPACE_NEXT, PT_STRING, "KeySysWorkspaceNext",
      _("Sys Workspace Next:"), _(""),
      { (int) "Alt+Ctrl+Right" }, 4 + 2 , GDK_Right },
    { KEY_SYS_WORKSPACE_PREV_TAKE_WIN, PT_STRING, "KeySysWorkspacePrevTakeWin",
      _("Sys Workspace Prev Take Win:"), _(""),
      { (int) "Alt+Ctrl+Shift+Left" }, 4 + 2 + 1 , GDK_Left },
    { KEY_SYS_WORKSPACE_NEXT_TAKE_WIN, PT_STRING, "KeySysWorkspaceNextTakeWin",
      _("Sys Workspace Next Take Win:"), _(""),
      { (int) "Alt+Ctrl+Shift+Right" }, 4 + 2 + 1 , GDK_Right },
    { KEY_SYS_WORKSPACE1, PT_STRING, "KeySysWorkspace1",
      _("Sys Workspace1:"), _(""),
      { (int) "Alt+Ctrl+1" }, 4 + 2 , '1' },
    { KEY_SYS_WORKSPACE2, PT_STRING, "KeySysWorkspace2",
      _("Sys Workspace2:"), _(""),
      { (int) "Alt+Ctrl+2" }, 4 + 2 , '2' },
    { KEY_SYS_WORKSPACE3, PT_STRING, "KeySysWorkspace3",
      _("Sys Workspace3:"), _(""),
      { (int) "Alt+Ctrl+3" }, 4 + 2 , '3' },
    { KEY_SYS_WORKSPACE4, PT_STRING, "KeySysWorkspace4",
      _("Sys Workspace4:"), _(""),
      { (int) "Alt+Ctrl+4" }, 4 + 2 , '4' },
    { KEY_SYS_WORKSPACE5, PT_STRING, "KeySysWorkspace5",
      _("Sys Workspace5:"), _(""),
      { (int) "Alt+Ctrl+5" }, 4 + 2 , '5' },
    { KEY_SYS_WORKSPACE6, PT_STRING, "KeySysWorkspace6",
      _("Sys Workspace6:"), _(""),
      { (int) "Alt+Ctrl+6" }, 4 + 2 , '6' },
    { KEY_SYS_WORKSPACE7, PT_STRING, "KeySysWorkspace7",
      _("Sys Workspace7:"), _(""),
      { (int) "Alt+Ctrl+7" }, 4 + 2 , '7' },
    { KEY_SYS_WORKSPACE8, PT_STRING, "KeySysWorkspace8",
      _("Sys Workspace8:"), _(""),
      { (int) "Alt+Ctrl+8" }, 4 + 2 , '8' },
    { KEY_SYS_WORKSPACE9, PT_STRING, "KeySysWorkspace9",
      _("Sys Workspace9:"), _(""),
      { (int) "Alt+Ctrl+9" }, 4 + 2 , '9' },
    { KEY_SYS_WORKSPACE10, PT_STRING, "KeySysWorkspace10",
      _("Sys Workspace10:"), _(""),
      { (int) "Alt+Ctrl+0" }, 4 + 2 , '0' },
    { KEY_SYS_WORKSPACE11, PT_STRING, "KeySysWorkspace11",
      _("Sys Workspace11:"), _(""),
      { (int) "Alt+Ctrl+[" }, 4 + 2 , '-' },
    { KEY_SYS_WORKSPACE12, PT_STRING, "KeySysWorkspace12",
      _("Sys Workspace12:"), _(""),
      { (int) "Alt+Ctrl+]" }, 4 + 2 , '=' },
    { KEY_SYS_WORKSPACE1_TAKE_WIN, PT_STRING, "KeySysWorkspace1TakeWin",
      _("Sys Workspace1 Take Win:"), _(""),
      { (int) "Alt+Ctrl+Shift+1" }, 4 + 2 + 1 , '1' },
    { KEY_SYS_WORKSPACE2_TAKE_WIN, PT_STRING, "KeySysWorkspace2TakeWin",
      _("Sys Workspace2 Take Win:"), _(""),
      { (int) "Alt+Ctrl+Shift+2" }, 4 + 2 + 1 , '2' },
    { KEY_SYS_WORKSPACE3_TAKE_WIN, PT_STRING, "KeySysWorkspace3TakeWin",
      _("Sys Workspace3 Take Win:"), _(""),
      { (int) "Alt+Ctrl+Shift+3" }, 4 + 2 + 1 , '3' },
    { KEY_SYS_WORKSPACE4_TAKE_WIN, PT_STRING, "KeySysWorkspace4TakeWin",
      _("Sys Workspace4 Take Win:"), _(""),
      { (int) "Alt+Ctrl+Shift+4" }, 4 + 2 + 1 , '4' },
    { KEY_SYS_WORKSPACE5_TAKE_WIN, PT_STRING, "KeySysWorkspace5TakeWin",
      _("Sys Workspace5 Take Win:"), _(""),
      { (int) "Alt+Ctrl+Shift+5" }, 4 + 2 + 1 , '5' },
    { KEY_SYS_WORKSPACE6_TAKE_WIN, PT_STRING, "KeySysWorkspace6TakeWin",
      _("Sys Workspace6 Take Win:"), _(""),
      { (int) "Alt+Ctrl+Shift+6" }, 4 + 2 + 1 , '6' },
    { KEY_SYS_WORKSPACE7_TAKE_WIN, PT_STRING, "KeySysWorkspace7TakeWin",
      _("Sys Workspace7 Take Win:"), _(""),
      { (int) "Alt+Ctrl+Shift+7" }, 4 + 2 + 1 , '7' },
    { KEY_SYS_WORKSPACE8_TAKE_WIN, PT_STRING, "KeySysWorkspace8TakeWin",
      _("Sys Workspace8 Take Win:"), _(""),
      { (int) "Alt+Ctrl+Shift+8" }, 4 + 2 + 1 , '8' },
    { KEY_SYS_WORKSPACE9_TAKE_WIN, PT_STRING, "KeySysWorkspace9TakeWin",
      _("Sys Workspace9 Take Win:"), _(""),
      { (int) "Alt+Ctrl+Shift+9" }, 4 + 2 + 1 , '9' },
    { KEY_SYS_WORKSPACE10_TAKE_WIN, PT_STRING, "KeySysWorkspace10TakeWin",
      _("Sys Workspace10 Take Win:"), _(""),
      { (int) "Alt+Ctrl+Shift+0" }, 4 + 2 + 1 , '0' },
    { KEY_SYS_WORKSPACE11_TAKE_WIN, PT_STRING, "KeySysWorkspace11TakeWin",
      _("Sys Workspace11 Take Win:"), _(""),
      { (int) "Alt+Ctrl+Shift+[" }, 4 + 2 + 1 , '-' },
    { KEY_SYS_WORKSPACE12_TAKE_WIN, PT_STRING, "KeySysWorkspace12TakeWin",
      _("Sys Workspace12 Take Win:"), _(""),
      { (int) "Alt+Ctrl+Shift+]" }, 4 + 2 + 1 , '=' },
};

PrefsNode::PropClass PrefsNode::prop_cl [PrefsNode::PROPERTY_COUNT] = {
    { CLICK_FOCUS, FOCUS },
    { RAISE_ONFOCUS, FOCUS },
    { FOCUS_ONCLICK_CLIENT, FOCUS },
    { RAISE_ONCLICK_CLIENT, FOCUS },
    { RAISE_ONCLICK_BUTTON, FOCUS },
    { RAISE_ONCLICK_FRAME, FOCUS },
    { RAISE_ONCLICK_TITLE_BAR, FOCUS },
    { PASS_FIRST_CLICK_TOCLIENT, FOCUS },
    { FOCUS_ONMAP, FOCUS },
    { FOCUS_ONMAP_TRANSIENT, FOCUS },
    { FOCUS_ONMAP_TRANSIENT_ACTIVE, FOCUS },
    { POINTER_COLORMAP, FOCUS },
    { SIZE_MAXIMIZED, WINDOW_PLACEMENT },
    { SHOW_MOVE_SIZE_STATUS, WINDOW_PLACEMENT },
    { BEEP_ONNEW_MAIL, TASK_BAR_APPLETS },
    { WARP_POINTER, WORKSPACES },
    { OPAQUE_MOVE, WINDOW_PLACEMENT },
    { OPAQUE_RESIZE, WINDOW_PLACEMENT },
    { SHOW_TASK_BAR, TASK_BAR },
    { TASK_BAR_ATTOP, TASK_BAR },
    { TASK_BAR_SHOW_CLOCK, TASK_BAR_APPLETS },
    { TASK_BAR_SHOW_APM, TASK_BAR_APPLETS },
    { TASK_BAR_SHOW_MAILBOX_STATUS, TASK_BAR_APPLETS },
    { TASK_BAR_SHOW_START_MENU, TASK_BAR },
    { TASK_BAR_SHOW_WINDOW_LIST_MENU, TASK_BAR },
    { TASK_BAR_SHOW_WORKSPACES, TASK_BAR },
    { TASK_BAR_SHOW_WINDOWS, TASK_BAR },
    { TASK_BAR_SHOW_ALL_WINDOWS, TASK_BAR },
    { TASK_BAR_AUTO_HIDE, TASK_BAR },
    { TASK_BAR_DOUBLE_HEIGHT, TASK_BAR },
    { TASK_BAR_SHOWCPU_STATUS, TASK_BAR_APPLETS },
    { TASK_BAR_SHOW_NET_STATUS, TASK_BAR_APPLETS },
    { TASK_BARCPU_SAMPLES, TASK_BAR_APPLETS },
    { MINIMIZE_TODESKTOP, WINDOW_PLACEMENT },
    { PRETTY_CLOCK, TASK_BAR_APPLETS },
    { MANUAL_PLACEMENT, WINDOW_PLACEMENT },
    { SMART_PLACEMENT, WINDOW_PLACEMENT },
    { CENTER_TRANSIENTS_ONOWNER, WINDOW_PLACEMENT },
    { MENU_MOUSE_TRACKING, MENUS },
    { AUTO_RAISE, FOCUS },
    { DELAY_POINTER_FOCUS, FOCUS },
    { USE_MOUSE_WHEEL, MOUSE_BUTTONS },
    { QUICK_SWITCH, FOCUS },
    { QUICK_SWITCH_TOMINIMIZED, FOCUS },
    { QUICK_SWITCH_TOHIDDEN, FOCUS },
    { QUICK_SWITCH_TOALL_WORKSPACES, FOCUS },
    { COUNT_MAIL_MESSAGES, TASK_BAR_APPLETS },
    { STRONG_POINTER_FOCUS, FOCUS },
    { GRAB_ROOT_WINDOW, FOCUS },
    { SNAP_MOVE, WINDOW_PLACEMENT },
    { CENTER_BACKGROUND, DESKTOP_BACKGROUND },
    { EDGE_WORKSPACE_SWITCHING, WORKSPACES },
    { SHOW_POPUPS_ABOVE_POINTER, BEHAVIOR },
    { REPLAY_MENU_CANCEL_CLICK, MENUS },
    { LIMIT_SIZE, WINDOW_PLACEMENT },
    { LIMIT_POSITION, WINDOW_PLACEMENT },
    { WIN95KEYS, BEHAVIOR },
    { MOD_META_ISCTRL_ALT, BEHAVIOR },
    { AUTO_RELOAD_MENUS, MENUS },
    { SHOW_FRAME_ICON, TITLE_BAR },
    { AUTO_DETECT_GNOME, BEHAVIOR },
    { CLIENT_MOUSE_ACTIONS, BEHAVIOR },
    { TITLE_BAR_CENTERED, TITLE_BAR },
    { SHOW_THEMES_MENU, MENUS },
    { CONFIRM_LOGOUT, BEHAVIOR },
    { WS_BORDERX, DECORATIONS },
    { WS_BORDERY, DECORATIONS },
    { WS_DLG_BORDERX, DECORATIONS },
    { WS_DLG_BORDERY, DECORATIONS },
    { WS_TITLE_BAR, DECORATIONS },
    { WS_CORNERX, DECORATIONS },
    { WS_CORNERY, DECORATIONS },
    { CLICK_MOTION_DISTANCE, BEHAVIOR },
    { CLICK_MOTION_DELAY, TIMINGS },
    { MULTI_CLICK_TIME, TIMINGS },
    { TOOL_TIP_DELAY, TIMINGS },
    { TOOL_TIP_TIME, TIMINGS },
    { MENU_ACTIVATE_DELAY, TIMINGS },
    { SUBMENU_ACTIVATE_DELAY, TIMINGS },
    { EDGE_RESISTANCE, WINDOW_PLACEMENT },
    { SNAP_DISTANCE, WINDOW_PLACEMENT },
    { POINTER_FOCUS_DELAY, TIMINGS },
    { AUTO_RAISE_DELAY, TIMINGS },
    { AUTO_HIDE_DELAY, TIMINGS },
    { EDGE_SWITCH_DELAY, TIMINGS },
    { SCROLL_BAR_START_DELAY, TIMINGS },
    { SCROLL_BAR_DELAY, TIMINGS },
    { AUTO_SCROLL_START_DELAY, TIMINGS },
    { AUTO_SCROLL_DELAY, TIMINGS },
    { USE_ROOT_BUTTONS, MOUSE_BUTTONS },
    { BUTTON_RAISE_MASK, MOUSE_BUTTONS },
    { ROOT_WIN_MENU_BUTTON, MOUSE_BUTTONS },
    { ROOT_WIN_LIST_BUTTON, MOUSE_BUTTONS },
    { ROOT_MENU_BUTTON, MOUSE_BUTTONS },
    { TITLE_MAXIMIZE_BUTTON, TITLE_BAR },
    { TITLE_ROLLUP_BUTTON, TITLE_BAR },
    { MAIL_CHECK_DELAY, TASK_BAR_APPLETS },
    { TITLE_BUTTONS_LEFT, TITLE_BAR },
    { TITLE_BUTTONS_RIGHT, TITLE_BAR },
    { TITLE_BUTTONS_SUPPORTED, THEME },
    { THEME_NAME, THEME },
    { THEME_AUTHOR, THEME },
    { THEME_DESCRIPTION, THEME },
    { TITLE_FONT_NAME, FONTS },
    { MENU_FONT_NAME, FONTS },
    { STATUS_FONT_NAME, FONTS },
    { SWITCH_FONT_NAME, FONTS },
    { NORMAL_BUTTON_FONT_NAME, FONTS },
    { ACTIVE_BUTTON_FONT_NAME, FONTS },
    { NORMAL_TASK_BAR_FONT_NAME, FONTS },
    { ACTIVE_TASK_BAR_FONT_NAME, FONTS },
    { MINIMIZED_WINDOW_FONT_NAME, FONTS },
    { LIST_BOX_FONT_NAME, FONTS },
    { TOOL_TIP_FONT_NAME, FONTS },
    { LABEL_FONT_NAME, FONTS },
    { CLOCK_FONT_NAME, FONTS },
    { APM_FONT_NAME, FONTS },
    { ICON_PATH, PATHS },
    { MAIL_BOX_PATH, PATHS },
    { MAIL_COMMAND, PROGRAMS },
    { NEW_MAIL_COMMAND, PROGRAMS },
    { LOCK_COMMAND, PROGRAMS },
    { CLOCK_COMMAND, PROGRAMS },
    { RUN_DLG_COMMAND, PROGRAMS },
    { OPEN_COMMAND, PROGRAMS },
    { TERMINAL_COMMAND, PROGRAMS },
    { LOGOUT_COMMAND, PROGRAMS },
    { LOGOUT_CANCEL_COMMAND, PROGRAMS },
    { SHUTDOWN_COMMAND, PROGRAMS },
    { REBOOT_COMMAND, PROGRAMS },
    { NET_DEVICE, TASK_BAR_APPLETS },
    { CPU_COMMAND, PROGRAMS },
    { NET_COMMAND, PROGRAMS },
    { ADDRESS_BAR_COMMAND, PROGRAMS },
    { FMT_TIME, TASK_BAR_APPLETS },
    { FMT_DATE, TASK_BAR_APPLETS },
    { CLR_DIALOG, COLORS },
    { CLR_ACTIVE_BORDER, COLORS },
    { CLR_INACTIVE_BORDER, COLORS },
    { CLR_NORMAL_TITLE_BUTTON, COLORS },
    { CLR_NORMAL_TITLE_BUTTON_TEXT, COLORS },
    { CLR_ACTIVE_TITLE_BAR, COLORS },
    { CLR_INACTIVE_TITLE_BAR, COLORS },
    { CLR_ACTIVE_TITLE_BAR_TEXT, COLORS },
    { CLR_INACTIVE_TITLE_BAR_TEXT, COLORS },
    { CLR_NORMAL_MINIMIZED_WINDOW, COLORS },
    { CLR_NORMAL_MINIMIZED_WINDOW_TEXT, COLORS },
    { CLR_ACTIVE_MINIMIZED_WINDOW, COLORS },
    { CLR_ACTIVE_MINIMIZED_WINDOW_TEXT, COLORS },
    { CLR_NORMAL_MENU, COLORS },
    { CLR_ACTIVE_MENU_ITEM, COLORS },
    { CLR_ACTIVE_MENU_ITEM_TEXT, COLORS },
    { CLR_NORMAL_MENU_ITEM_TEXT, COLORS },
    { CLR_DISABLED_MENU_ITEM_TEXT, COLORS },
    { CLR_MOVE_SIZE_STATUS, COLORS },
    { CLR_MOVE_SIZE_STATUS_TEXT, COLORS },
    { CLR_QUICK_SWITCH, COLORS },
    { CLR_QUICK_SWITCH_TEXT, COLORS },
    { CLR_DEFAULT_TASK_BAR, COLORS },
    { CLR_NORMAL_BUTTON, COLORS },
    { CLR_NORMAL_BUTTON_TEXT, COLORS },
    { CLR_ACTIVE_BUTTON, COLORS },
    { CLR_ACTIVE_BUTTON_TEXT, COLORS },
    { CLR_NORMAL_TASK_BAR_APP, COLORS },
    { CLR_NORMAL_TASK_BAR_APP_TEXT, COLORS },
    { CLR_ACTIVE_TASK_BAR_APP, COLORS },
    { CLR_ACTIVE_TASK_BAR_APP_TEXT, COLORS },
    { CLR_MINIMIZED_TASK_BAR_APP, COLORS },
    { CLR_MINIMIZED_TASK_BAR_APP_TEXT, COLORS },
    { CLR_INVISIBLE_TASK_BAR_APP, COLORS },
    { CLR_INVISIBLE_TASK_BAR_APP_TEXT, COLORS },
    { CLR_SCROLL_BAR, COLORS },
    { CLR_SCROLL_BAR_ARROW, COLORS },
    { CLR_SCROLL_BAR_SLIDER, COLORS },
    { CLR_LIST_BOX, COLORS },
    { CLR_LIST_BOX_TEXT, COLORS },
    { CLR_LIST_BOX_SELECTED, COLORS },
    { CLR_LIST_BOX_SELECTED_TEXT, COLORS },
    { CLR_TOOL_TIP, COLORS },
    { CLR_TOOL_TIP_TEXT, COLORS },
    { CLR_CLOCK, COLORS },
    { CLR_CLOCK_TEXT, COLORS },
    { CLR_APM, COLORS },
    { CLR_APM_TEXT, COLORS },
    { CLR_INPUT, COLORS },
    { CLR_INPUT_TEXT, COLORS },
    { CLR_INPUT_SELECTION, COLORS },
    { CLR_INPUT_SELECTION_TEXT, COLORS },
    { CLR_LABEL, COLORS },
    { CLR_LABEL_TEXT, COLORS },
    { CLR_CPU_USER, COLORS },
    { CLR_CPU_SYS, COLORS },
    { CLR_CPU_NICE, COLORS },
    { CLR_CPU_IDLE, COLORS },
    { CLR_NET_SEND, COLORS },
    { CLR_NET_RECEIVE, COLORS },
    { CLR_NET_IDLE, COLORS },
    { DESKTOP_BACKGROUND_COLOR, DESKTOP_BACKGROUND },
    { DESKTOP_BACKGROUND_PIXMAP, DESKTOP_BACKGROUND },
    { KEY_WIN_RAISE, KEY_BINDINGS },
    { KEY_WIN_OCCUPY_ALL, KEY_BINDINGS },
    { KEY_WIN_LOWER, KEY_BINDINGS },
    { KEY_WIN_CLOSE, KEY_BINDINGS },
    { KEY_WIN_RESTORE, KEY_BINDINGS },
    { KEY_WIN_PREV, KEY_BINDINGS },
    { KEY_WIN_NEXT, KEY_BINDINGS },
    { KEY_WIN_MOVE, KEY_BINDINGS },
    { KEY_WIN_SIZE, KEY_BINDINGS },
    { KEY_WIN_MINIMIZE, KEY_BINDINGS },
    { KEY_WIN_MAXIMIZE, KEY_BINDINGS },
    { KEY_WIN_MAXIMIZE_VERT, KEY_BINDINGS },
    { KEY_WIN_HIDE, KEY_BINDINGS },
    { KEY_WIN_ROLLUP, KEY_BINDINGS },
    { KEY_WIN_MENU, KEY_BINDINGS },
    { KEY_SYS_SWITCH_NEXT, KEY_BINDINGS },
    { KEY_SYS_SWITCH_LAST, KEY_BINDINGS },
    { KEY_SYS_WIN_NEXT, KEY_BINDINGS },
    { KEY_SYS_WIN_PREV, KEY_BINDINGS },
    { KEY_SYS_WIN_MENU, KEY_BINDINGS },
    { KEY_SYS_DIALOG, KEY_BINDINGS },
    { KEY_SYS_MENU, KEY_BINDINGS },
    { KEY_SYS_RUN, KEY_BINDINGS },
    { KEY_SYS_WINDOW_LIST, KEY_BINDINGS },
    { KEY_SYS_ADDRESS_BAR, KEY_BINDINGS },
    { KEY_SYS_WORKSPACE_PREV, KEY_BINDINGS },
    { KEY_SYS_WORKSPACE_NEXT, KEY_BINDINGS },
    { KEY_SYS_WORKSPACE_PREV_TAKE_WIN, KEY_BINDINGS },
    { KEY_SYS_WORKSPACE_NEXT_TAKE_WIN, KEY_BINDINGS },
    { KEY_SYS_WORKSPACE1, KEY_BINDINGS },
    { KEY_SYS_WORKSPACE2, KEY_BINDINGS },
    { KEY_SYS_WORKSPACE3, KEY_BINDINGS },
    { KEY_SYS_WORKSPACE4, KEY_BINDINGS },
    { KEY_SYS_WORKSPACE5, KEY_BINDINGS },
    { KEY_SYS_WORKSPACE6, KEY_BINDINGS },
    { KEY_SYS_WORKSPACE7, KEY_BINDINGS },
    { KEY_SYS_WORKSPACE8, KEY_BINDINGS },
    { KEY_SYS_WORKSPACE9, KEY_BINDINGS },
    { KEY_SYS_WORKSPACE10, KEY_BINDINGS },
    { KEY_SYS_WORKSPACE11, KEY_BINDINGS },
    { KEY_SYS_WORKSPACE12, KEY_BINDINGS },
    { KEY_SYS_WORKSPACE1_TAKE_WIN, KEY_BINDINGS },
    { KEY_SYS_WORKSPACE2_TAKE_WIN, KEY_BINDINGS },
    { KEY_SYS_WORKSPACE3_TAKE_WIN, KEY_BINDINGS },
    { KEY_SYS_WORKSPACE4_TAKE_WIN, KEY_BINDINGS },
    { KEY_SYS_WORKSPACE5_TAKE_WIN, KEY_BINDINGS },
    { KEY_SYS_WORKSPACE6_TAKE_WIN, KEY_BINDINGS },
    { KEY_SYS_WORKSPACE7_TAKE_WIN, KEY_BINDINGS },
    { KEY_SYS_WORKSPACE8_TAKE_WIN, KEY_BINDINGS },
    { KEY_SYS_WORKSPACE9_TAKE_WIN, KEY_BINDINGS },
    { KEY_SYS_WORKSPACE10_TAKE_WIN, KEY_BINDINGS },
    { KEY_SYS_WORKSPACE11_TAKE_WIN, KEY_BINDINGS },
    { KEY_SYS_WORKSPACE12_TAKE_WIN, KEY_BINDINGS },
};

PropertyNode::PropValue	PrefsNode::prop_val [PrefsNode::PROPERTY_COUNT];
GtkWidget*		PrefsNode::prop_ed [PrefsNode::PROPERTY_COUNT];
GtkWidget*		PrefsNode::sect_ed [PrefsNode::SECTION_COUNT];

const char*	PrefsNode::sect_lb [PROPERTY_COUNT] = {
    _("Focus"), _("Window Placement"), _("Behavior"), _("Timings"),
    _("Mouse Buttons"), _("Menus"), _("Task Bar"), _("Task Bar Applets"),
    _("Paths"), _("External Programs"), _("Workspaces"),
    _("Desktop Background"), _("Theme"), _("Colors"),  _("Fonts"), 
    _("Key Bindings"), _("Title Bar"), _("Decorations"),
    _("Unknown")
};

GtkWidget* PrefsNode::get_editor	(void) {
    if (!sect_ed [section]) {
        sect_ed [section] = create_editor ();
        synchronize_property_editors ();
    }
    
    grab_current (this);
    
    return sect_ed [section];
}
    
GtkWidget* PrefsNode::create_editor	(void) {
    g_return_val_if_fail (sect_ed [section] == NULL, sect_ed [section]);
    gtk_widget_ref (sect_ed [section] = gtk_table_new (6, 0, FALSE));
    gtk_table_set_col_spacings  (GTK_TABLE (sect_ed [section]), 4);
    gtk_container_set_border_width (GTK_CONTAINER (sect_ed [section]), 5);
    
    for (unsigned n = 0, row = 1; n < PROPERTY_COUNT; ++n) {
        g_assert ((unsigned) prop_cl [n].id == n);
        if (prop_cl [n].sect == section)
	    create_property_editor (n, GTK_TABLE (sect_ed [section]), 
	    			    ++row, 1, 2, 3);
    }
    
    return sect_ed [section];
}
