#ifndef __PREFS_NODE_H__
#define __PREFS_NODE_H__

#include "config.h"
#include "propertynode.h"

IceWM_CM_BEGIN_NAMESPACE

class PrefsNode : public PropertyNode {
public:
    enum PropId {
         CLICK_FOCUS, RAISE_ONFOCUS, FOCUS_ONCLICK_CLIENT,
         RAISE_ONCLICK_CLIENT, RAISE_ONCLICK_BUTTON, RAISE_ONCLICK_FRAME,
         RAISE_ONCLICK_TITLE_BAR, PASS_FIRST_CLICK_TOCLIENT, FOCUS_ONMAP,
         FOCUS_ONMAP_TRANSIENT, FOCUS_ONMAP_TRANSIENT_ACTIVE, POINTER_COLORMAP,
         SIZE_MAXIMIZED, SHOW_MOVE_SIZE_STATUS, BEEP_ONNEW_MAIL, WARP_POINTER,
         OPAQUE_MOVE, OPAQUE_RESIZE, SHOW_TASK_BAR, TASK_BAR_ATTOP,
         TASK_BAR_SHOW_CLOCK, TASK_BAR_SHOW_APM, TASK_BAR_SHOW_MAILBOX_STATUS,
         TASK_BAR_SHOW_START_MENU, TASK_BAR_SHOW_WINDOW_LIST_MENU,
         TASK_BAR_SHOW_WORKSPACES, TASK_BAR_SHOW_WINDOWS,
         TASK_BAR_SHOW_ALL_WINDOWS, TASK_BAR_AUTO_HIDE, TASK_BAR_DOUBLE_HEIGHT,
         TASK_BAR_SHOWCPU_STATUS, TASK_BAR_SHOW_NET_STATUS,
         TASK_BARCPU_SAMPLES, MINIMIZE_TODESKTOP, PRETTY_CLOCK,
         MANUAL_PLACEMENT, SMART_PLACEMENT, CENTER_TRANSIENTS_ONOWNER,
         MENU_MOUSE_TRACKING, AUTO_RAISE, DELAY_POINTER_FOCUS, USE_MOUSE_WHEEL,
         QUICK_SWITCH, QUICK_SWITCH_TOMINIMIZED, QUICK_SWITCH_TOHIDDEN,
         QUICK_SWITCH_TOALL_WORKSPACES, COUNT_MAIL_MESSAGES,
         STRONG_POINTER_FOCUS, GRAB_ROOT_WINDOW, SNAP_MOVE, CENTER_BACKGROUND,
         EDGE_WORKSPACE_SWITCHING, SHOW_POPUPS_ABOVE_POINTER,
         REPLAY_MENU_CANCEL_CLICK, LIMIT_SIZE, LIMIT_POSITION, WIN95KEYS,
         MOD_META_ISCTRL_ALT, AUTO_RELOAD_MENUS, SHOW_FRAME_ICON,
         AUTO_DETECT_GNOME, CLIENT_MOUSE_ACTIONS, TITLE_BAR_CENTERED,
         SHOW_THEMES_MENU, CONFIRM_LOGOUT, WS_BORDERX, WS_BORDERY,
         WS_DLG_BORDERX, WS_DLG_BORDERY, WS_TITLE_BAR, WS_CORNERX, WS_CORNERY,
         CLICK_MOTION_DISTANCE, CLICK_MOTION_DELAY, MULTI_CLICK_TIME,
         TOOL_TIP_DELAY, TOOL_TIP_TIME, MENU_ACTIVATE_DELAY,
         SUBMENU_ACTIVATE_DELAY, EDGE_RESISTANCE, SNAP_DISTANCE,
         POINTER_FOCUS_DELAY, AUTO_RAISE_DELAY, AUTO_HIDE_DELAY,
         EDGE_SWITCH_DELAY, SCROLL_BAR_START_DELAY, SCROLL_BAR_DELAY,
         AUTO_SCROLL_START_DELAY, AUTO_SCROLL_DELAY, USE_ROOT_BUTTONS,
         BUTTON_RAISE_MASK, ROOT_WIN_MENU_BUTTON, ROOT_WIN_LIST_BUTTON,
         ROOT_MENU_BUTTON, TITLE_MAXIMIZE_BUTTON, TITLE_ROLLUP_BUTTON,
         MAIL_CHECK_DELAY, TITLE_BUTTONS_LEFT, TITLE_BUTTONS_RIGHT,
         TITLE_BUTTONS_SUPPORTED, THEME_NAME, THEME_AUTHOR, THEME_DESCRIPTION,
         TITLE_FONT_NAME, MENU_FONT_NAME, STATUS_FONT_NAME, SWITCH_FONT_NAME,
         NORMAL_BUTTON_FONT_NAME, ACTIVE_BUTTON_FONT_NAME,
         NORMAL_TASK_BAR_FONT_NAME, ACTIVE_TASK_BAR_FONT_NAME,
         MINIMIZED_WINDOW_FONT_NAME, LIST_BOX_FONT_NAME, TOOL_TIP_FONT_NAME,
         LABEL_FONT_NAME, CLOCK_FONT_NAME, APM_FONT_NAME, ICON_PATH,
         MAIL_BOX_PATH, MAIL_COMMAND, NEW_MAIL_COMMAND, LOCK_COMMAND,
         CLOCK_COMMAND, RUN_DLG_COMMAND, OPEN_COMMAND, TERMINAL_COMMAND,
         LOGOUT_COMMAND, LOGOUT_CANCEL_COMMAND, SHUTDOWN_COMMAND,
         REBOOT_COMMAND, NET_DEVICE, CPU_COMMAND, NET_COMMAND,
         ADDRESS_BAR_COMMAND, FMT_TIME, FMT_DATE, CLR_DIALOG,
         CLR_ACTIVE_BORDER, CLR_INACTIVE_BORDER, CLR_NORMAL_TITLE_BUTTON,
         CLR_NORMAL_TITLE_BUTTON_TEXT, CLR_ACTIVE_TITLE_BAR,
         CLR_INACTIVE_TITLE_BAR, CLR_ACTIVE_TITLE_BAR_TEXT,
         CLR_INACTIVE_TITLE_BAR_TEXT, CLR_NORMAL_MINIMIZED_WINDOW,
         CLR_NORMAL_MINIMIZED_WINDOW_TEXT, CLR_ACTIVE_MINIMIZED_WINDOW,
         CLR_ACTIVE_MINIMIZED_WINDOW_TEXT, CLR_NORMAL_MENU,
         CLR_ACTIVE_MENU_ITEM, CLR_ACTIVE_MENU_ITEM_TEXT,
         CLR_NORMAL_MENU_ITEM_TEXT, CLR_DISABLED_MENU_ITEM_TEXT,
         CLR_MOVE_SIZE_STATUS, CLR_MOVE_SIZE_STATUS_TEXT, CLR_QUICK_SWITCH,
         CLR_QUICK_SWITCH_TEXT, CLR_DEFAULT_TASK_BAR, CLR_NORMAL_BUTTON,
         CLR_NORMAL_BUTTON_TEXT, CLR_ACTIVE_BUTTON, CLR_ACTIVE_BUTTON_TEXT,
         CLR_NORMAL_TASK_BAR_APP, CLR_NORMAL_TASK_BAR_APP_TEXT,
         CLR_ACTIVE_TASK_BAR_APP, CLR_ACTIVE_TASK_BAR_APP_TEXT,
         CLR_MINIMIZED_TASK_BAR_APP, CLR_MINIMIZED_TASK_BAR_APP_TEXT,
         CLR_INVISIBLE_TASK_BAR_APP, CLR_INVISIBLE_TASK_BAR_APP_TEXT,
         CLR_SCROLL_BAR, CLR_SCROLL_BAR_ARROW, CLR_SCROLL_BAR_SLIDER,
         CLR_LIST_BOX, CLR_LIST_BOX_TEXT, CLR_LIST_BOX_SELECTED,
         CLR_LIST_BOX_SELECTED_TEXT, CLR_TOOL_TIP, CLR_TOOL_TIP_TEXT,
         CLR_CLOCK, CLR_CLOCK_TEXT, CLR_APM, CLR_APM_TEXT, CLR_INPUT,
         CLR_INPUT_TEXT, CLR_INPUT_SELECTION, CLR_INPUT_SELECTION_TEXT,
         CLR_LABEL, CLR_LABEL_TEXT, CLR_CPU_USER, CLR_CPU_SYS, CLR_CPU_NICE,
         CLR_CPU_IDLE, CLR_NET_SEND, CLR_NET_RECEIVE, CLR_NET_IDLE,
         DESKTOP_BACKGROUND_COLOR, DESKTOP_BACKGROUND_PIXMAP, KEY_WIN_RAISE,
         KEY_WIN_OCCUPY_ALL, KEY_WIN_LOWER, KEY_WIN_CLOSE, KEY_WIN_RESTORE,
         KEY_WIN_PREV, KEY_WIN_NEXT, KEY_WIN_MOVE, KEY_WIN_SIZE,
         KEY_WIN_MINIMIZE, KEY_WIN_MAXIMIZE, KEY_WIN_MAXIMIZE_VERT,
         KEY_WIN_HIDE, KEY_WIN_ROLLUP, KEY_WIN_MENU, KEY_SYS_SWITCH_NEXT,
         KEY_SYS_SWITCH_LAST, KEY_SYS_WIN_NEXT, KEY_SYS_WIN_PREV,
         KEY_SYS_WIN_MENU, KEY_SYS_DIALOG, KEY_SYS_MENU, KEY_SYS_RUN,
         KEY_SYS_WINDOW_LIST, KEY_SYS_ADDRESS_BAR, KEY_SYS_WORKSPACE_PREV,
         KEY_SYS_WORKSPACE_NEXT, KEY_SYS_WORKSPACE_PREV_TAKE_WIN,
         KEY_SYS_WORKSPACE_NEXT_TAKE_WIN, KEY_SYS_WORKSPACE1,
         KEY_SYS_WORKSPACE2, KEY_SYS_WORKSPACE3, KEY_SYS_WORKSPACE4,
         KEY_SYS_WORKSPACE5, KEY_SYS_WORKSPACE6, KEY_SYS_WORKSPACE7,
         KEY_SYS_WORKSPACE8, KEY_SYS_WORKSPACE9, KEY_SYS_WORKSPACE10,
         KEY_SYS_WORKSPACE11, KEY_SYS_WORKSPACE12, KEY_SYS_WORKSPACE1_TAKE_WIN,
         KEY_SYS_WORKSPACE2_TAKE_WIN, KEY_SYS_WORKSPACE3_TAKE_WIN,
         KEY_SYS_WORKSPACE4_TAKE_WIN, KEY_SYS_WORKSPACE5_TAKE_WIN,
         KEY_SYS_WORKSPACE6_TAKE_WIN, KEY_SYS_WORKSPACE7_TAKE_WIN,
         KEY_SYS_WORKSPACE8_TAKE_WIN, KEY_SYS_WORKSPACE9_TAKE_WIN,
         KEY_SYS_WORKSPACE10_TAKE_WIN, KEY_SYS_WORKSPACE11_TAKE_WIN,
         KEY_SYS_WORKSPACE12_TAKE_WIN,
         PROPERTY_COUNT
    };
    
    enum SectId {
	 FOCUS, WINDOW_PLACEMENT, BEHAVIOR, TIMINGS, MOUSE_BUTTONS, MENUS, 
	 TASK_BAR, TASK_BAR_APPLETS, PATHS, PROGRAMS,
	 WORKSPACES, DESKTOP_BACKGROUND, THEME, COLORS, FONTS, KEY_BINDINGS,
	 TITLE_BAR, DECORATIONS,
	 UNKNOWN, SECTION_COUNT
    };

    static PropDef			prop_df [PROPERTY_COUNT];
    static struct PropClass {
        const PropId			id;
	const SectId			sect;
    }					prop_cl [PROPERTY_COUNT];

protected:    
    static PropValue			prop_val [PROPERTY_COUNT];
    static GtkWidget*			prop_ed [PROPERTY_COUNT];
    static GtkWidget*			sect_ed [SECTION_COUNT];
    static const char*			sect_lb [PROPERTY_COUNT];

    SectId				section;

public:
    PrefsNode				(SectId		section);

    virtual const char* get_label	(void) { return sect_lb [section]; }
    virtual GtkWidget* get_editor	(void);
    
protected:    
    virtual unsigned prop_count		(void) { return PROPERTY_COUNT; }
    virtual PropValue& property		(const unsigned	index);
    virtual PropDef& prop_def		(const unsigned	index);
    virtual GtkWidget*& prop_editor	(const unsigned	index);
    
    GtkWidget* create_editor		(void);
    virtual void synchronize_content	(void) { ungrab_current (this); }
};

inline PrefsNode::PrefsNode		(SectId		section) {
    g_assert (section >= 0 && section < SECTION_COUNT);
    this->section = section;
    
    init_properties ();
}

inline PropertyNode::PropValue& PrefsNode::property
					(const unsigned	index) {
    g_assert (index < PROPERTY_COUNT);
    return prop_val [index];
}

inline PropertyNode::PropDef& PrefsNode::prop_def
					(const unsigned	index) {
    g_assert (index < PROPERTY_COUNT);
    return prop_df [index];
}

inline GtkWidget*& PrefsNode::prop_editor
					(const unsigned	index) {
    g_assert (index < PROPERTY_COUNT);
    return prop_ed [index];
}

IceWM_CM_END_NAMESPACE

#endif
