#ifndef __PREFS_ROOT_H__
#define __PREFS_ROOT_H__

#include "config.h"
#include "rootnode.h"
#include "prefsnode.h"

IceWM_CM_BEGIN_NAMESPACE

class PrefsRoot : public RootNode {
public:
    virtual const char* get_label	(void) { return _("Preferences"); }
    virtual void create_sub_tree	(Hierachy*	hierachy,
    					 GtkCTreeNode*	node);
    virtual void load			(Location	location,
			 		 const char*	custom_file = 0) { }
    virtual void store			(Location	location,
			 		 const char*	custom_file = 0) { }
};

inline void PrefsRoot::create_sub_tree	(Hierachy*	hierachy,
    					 GtkCTreeNode*	node) {
    for (unsigned sect = 0; sect < PrefsNode::SECTION_COUNT; ++sect)
        hierachy->insert_tree_node (new PrefsNode ((PrefsNode::SectId) sect), 
	                            node);
};

IceWM_CM_END_NAMESPACE

#endif
