#ifndef __PROGRAM_H__
#define __PROGRAM_H__

#include "menunode.h"

IceWM_CM_BEGIN_NAMESPACE

class Program : public MenuNode {
protected:
    PropValue prop_val			[2];

public:
    Program				(const char*	label,
    					 const char*	icon,
					 const char*	command,
					 bool		restart);
    virtual ostream& store		(ostream&	os);
    
protected:
    virtual unsigned prop_count		(void) { return 4; }
    virtual PropValue& property		(const unsigned	index);
    virtual GtkWidget*& Program::prop_editor
					(const unsigned	index);
    virtual GtkWidget* get_top_panel	(void);
    
    virtual const char* get_title	(void) { return _("Application"); }

private:
    static GtkWidget*			top_panel;
};

inline Program::Program			(const char*	label,
					 const char*	icon,
					 const char*	command,
                                         bool		restart) {
    g_assert (label);
    g_assert (command);

    init_properties ();
    
    set_property (LABEL, label);
    set_property (ICON, icon);
    set_property (COMMAND, command);
    set_property (RESTART, restart);
}

inline ostream& Program::store		(ostream&	os) {
    return os << (get_boolean (RESTART) ? "restart \"" : "prog \"") 
              << get_string (LABEL) << "\" " << icon_name () << ' '
	      << get_string (COMMAND);
}

inline PropertyNode::PropValue& Program::property
					(const unsigned	index) {
    g_assert (index < prop_count ());
    return prop_val [index];
}

inline GtkWidget*& Program::prop_editor
					(const unsigned	index) {
    g_assert (index < prop_count ());
    return prop_ed [index + 2];
}

inline GtkWidget* Program::get_top_panel
					(void) {
    if (Program::top_panel == NULL)
        gtk_widget_ref (Program::top_panel = create_top_panel ());
    return Program::top_panel;
}

IceWM_CM_END_NAMESPACE

#endif
