#ifndef __ROOT_NODE_H__
#define __ROOT_NODE_H__

#include "config.h"
#include "treenode.h"

IceWM_CM_BEGIN_NAMESPACE

class Hierachy;

class RootNode : public TreeNode {
protected:
    Hierachy*				hierachy;
    struct GtkCTreeNode*		ctree_node;

public:
    enum Location {
        LOC_PRIVATE,
	LOC_SYSTEM,
	LOC_DEFAULT,
	LOC_CUSTOM
    };

    virtual void create_sub_tree	(Hierachy*	hierachy,
    					 GtkCTreeNode*	node);
    virtual bool is_leaf		(void) { return false; }
    virtual void load			(Location	location,
			 		 const char*	custom_file = 0) = 0;
    virtual void store			(Location	location,
			 		 const char*	custom_file = 0) = 0;
};

inline void RootNode::create_sub_tree	(Hierachy*	hierachy,
    					 GtkCTreeNode*	node) {
    this->hierachy = hierachy;
    this->ctree_node = node;
}

IceWM_CM_END_NAMESPACE

#endif
