#ifndef __SUBMENU_H__
#define __SUBMENU_H__

#include "menunode.h"

IceWM_CM_BEGIN_NAMESPACE

class Submenu : public MenuNode {
protected:
    PropValue prop_val			[2];

public:
    Submenu				(const char*	label,
    					 const char*	icon);
    virtual bool is_leaf		(void) { return false; }
    virtual ostream& store		(ostream&	os);
    
protected:
    virtual unsigned prop_count		(void) { return 2; }
    virtual PropValue& property		(const unsigned	index);
    virtual GtkWidget* get_top_panel	(void);
    
    virtual const char* get_title	(void) { return _("Submenu"); }
    
private:
    static GtkWidget*			top_panel;
};

inline Submenu::Submenu			(const char*	label,
					 const char*	icon) {
    g_assert (label);

    init_properties ();
    
    set_property (LABEL, label);
    set_property (ICON, icon);
}

inline ostream& Submenu::store		(ostream&	os) {
    return os << "menu \"" << get_string (LABEL) << "\" " << icon_name ();
}

inline PropertyNode::PropValue& Submenu::property
					(const unsigned	index) {
    g_assert (index < prop_count ());
    return prop_val [index];
}

inline GtkWidget* Submenu::get_top_panel
					(void) {
    if (Submenu::top_panel == NULL)
        gtk_widget_ref (Submenu::top_panel = create_top_panel ());
    return Submenu::top_panel;
}

IceWM_CM_END_NAMESPACE

#endif
