#ifndef __TOOLBAR_H__
#define __TOOLBAR_H__

#include "config.h"
#include "treenode.h"

IceWM_CM_BEGIN_NAMESPACE

class Toolbar {
public:
    Toolbar				(void) { }

private:
    TreeNode::InsertionInfo*		insertion_info;
    static TreeNode::InsertionInfo	storage_menu [];

    GtkToolbar*				widget;
    GtkWidget*				insertion_menu;
    GtkWidget*				delete_button;
    GtkWidget*				move_up_button;
    GtkWidget*				move_down_button;
    GtkWidget*				load_menu;
    GtkWidget*				store_menu;

public:
    GtkWidget* init			(void);
    void setup_insertion_menu		(void);
    void update_widgets			(void);
    
private:
    GtkWidget* create_menu		(void);
    void fill_menu			(GtkWidget*	menu,
    					 TreeNode::InsertionInfo*
    							items,
    					 TreeNode::InsertionInfo*
					 		default_item,
					 const char*	default_label,
					 const char*	tooltip,
					 const char*	tooltip_private);
public:
    void close_menu			(GtkWidget*	button,
    					 TreeNode::InsertionInfo*
					 		default_item,
    					 const char*	default_label);
private:
    static void command_delete		(GtkWidget*	widget,
    					 gpointer	user_data);
    static void command_move_up		(GtkWidget*	widget,
    					 gpointer	user_data);
    static void command_move_down	(GtkWidget*	widget,
    					 gpointer	user_data);
    static void command_quit		(GtkWidget*	widget,
    					 gpointer	user_data);
    static void commmand_private_config	(GtkWidget*	widget,
    					 bool		store);
    static void commmand_system_config	(GtkWidget*	widget,
    					 bool		store);
    static void commmand_default_config	(GtkWidget*	widget,
    					 bool		store);
    static void commmand_custom_config	(GtkWidget*	widget,
    					 bool		store);
};

IceWM_CM_END_NAMESPACE

#endif
