#ifndef __GTK_HREF_H__
#define __GTK_HREF_H__

#ifndef __GTK_H__
#include <gtk/gtk.h>
#endif /* __GTK_H__ */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define GTK_HREF(obj) \
    GTK_CHECK_CAST (obj, gtk_href_get_type (), GtkHRef)
#define GTK_HREF_CLASS(class) \
    GTK_CHECK_CLASS_CAST (class, gtk_href_get_type (), GtkHRefClass)
#define GTK_IS_HREF(obj) \
    GTK_CHECK_TYPE (obj, gtk_href_get_type ())

typedef struct _GtkHRef			GtkHRef;
typedef struct _GtkHRefClass		GtkHRefClass;

struct _GtkHRef {
    GtkEventBox				event_box;
    gchar				*url;
};

struct _GtkHRefClass {
    GtkEventBoxClass			parent_class;
};

GtkType gtk_href_get_type		(void);
GtkWidget* gtk_href_new			(const gchar*	url,
					 const gchar*	label);
const gchar* gtk_href_get_url		(GtkHRef*	href);
void gtk_href_set_label			(GtkHRef*	href,
					 const gchar*	label);
void gtk_href_set_url			(GtkHRef*	href,
					 const gchar*	url);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __GTK_HREF_H__ */
