#ifndef __GTK_PEERED_BUTTONS_H__
#define __GTK_PEERED_BUTTONS_H__

#ifndef __GTK_H__
#include <gtk/gtk.h>
#endif /* __GTK_H__ */

#ifdef __cplusplus
extern "C" {
#define this me
#endif /* __cplusplus */

#define GTK_PEERED_BUTTONS(obj) \
	GTK_CHECK_CAST (obj, gtk_peered_buttons_get_type (), GtkPeeredButtons)
#define GTK_PEERED_BUTTONS_CLASS(class) \
	GTK_CHECK_CLASS_CAST (class, gtk_peered_buttons_get_type (), \
	                      GtkPeeredButtonsClass)
#define GTK_IS_PEERED_BUTTONS(obj) \
	GTK_CHECK_TYPE (obj, gtk_peered_buttons_get_type ())

typedef struct _GtkPeeredButtons	GtkPeeredButtons;
typedef struct _GtkPeeredButtonsClass	GtkPeeredButtonsClass;

struct _GtkPeeredButtons {
    GtkHBox		hbox;
    GtkWidget		*left;
    GtkWidget		*right;
    GtkWidget		*box;

/* private */    
    GtkWidget		*popup;
    guint		action_handler;
    guint		popup_handler;
    GtkWidget		*popup_button;
    GtkTooltips		*tooltips;
    GtkReliefStyle	relief;
};

struct _GtkPeeredButtonsClass {
    GtkHBoxClass parent_class;
};

GtkType    gtk_peered_buttons_get_type 	(void);
GtkWidget* gtk_peered_buttons_new      	(void);
GtkWidget* gtk_peered_buttons_new_with_labels
					(const gchar		*left,
					 const gchar		*right);
GtkWidget* gtk_peered_buttons_new_with_arrow_left
					(const gchar		*text,
					 GtkShadowType		shadow);
GtkWidget* gtk_peered_buttons_new_with_arrow_right
					(const gchar		*text,
					 GtkShadowType		shadow);
void gtk_peered_buttons_popup_left	(GtkPeeredButtons	*this);
void gtk_peered_buttons_popup_right	(GtkPeeredButtons	*this);
void gtk_peered_buttons_set_relief	(GtkPeeredButtons	*this,
					 GtkReliefStyle		relief);
void gtk_peered_buttons_set_tooltips	(GtkPeeredButtons	*this,
					 GtkTooltips		*tooltips);
void gtk_peered_buttons_set_default_action
					(GtkPeeredButtons	*this,
					 const gchar		*label,
					 const gchar		*tip_text,
					 const gchar		*tip_private,
					 GtkSignalFunc		callback,
					 gpointer		user_data);
GtkWidget* gtk_peered_buttons_append_widget
					(GtkPeeredButtons	*this,
					 GtkWidget		*widget,
					 const gchar		*tip_text,
					 const gchar		*tip_private);
GtkWidget* gtk_peered_buttons_append_item
					(GtkPeeredButtons	*this,
					 const gchar		*text,
					 const gchar		*tip_text,
					 const gchar		*tip_private,
					 GtkSignalFunc		callback,
					 gpointer		user_data);
void gtk_peered_buttons_remove_widget	(GtkPeeredButtons	*this,
					 GtkWidget		*widget);
void gtk_peered_buttons_remove_all_widgets
					(GtkPeeredButtons	*this);

#ifdef __cplusplus
#undef this
}
#endif /* __cplusplus */

#endif /* __GTK_PEERED_BUTTONS_H__ */
