#ifndef __WINOPT_ROOT_H__
#define __WINOPT_ROOT_H__

#include "config.h"
#include "rootnode.h"
#include "lexer.h"

IceWM_CM_BEGIN_NAMESPACE

class WinOptRoot : public RootNode {
public:
    virtual const char* get_label	(void) { return _("Window Options"); }
    virtual bool is_leaf		(void) { return false; }
    virtual void load			(Location	location,
			 		 const char*	custom_file = 0);
    virtual void store			(Location	location,
			 		 const char*	custom_file = 0);
    virtual InsertionInfo* insertion_list
    					(void);

protected:
    void parse_option			(Lexer&		lexer);
    GtkCTreeNode* find_class		(const char*	wm_class);
    GtkCTreeNode* find_window		(GtkCTreeNode*	class_node,
    					 const char*	wm_name);
    GtkCTreeNode* find_window		(const char*	wm_class,
    					 const char*	wm_name);
};

inline GtkCTreeNode* WinOptRoot::find_window
					(const char*	wm_class,
    					 const char*	wm_name) {
    return find_window (find_class (wm_class), wm_name);
}
					 
IceWM_CM_END_NAMESPACE

#endif
