#!/bin/sh

cd ..

patch=src/prefsnode.patch

APPLY=0
REMOVE=0
DRYRUN=

[ -f ${patch} ] && REMOVE=1

while [ $# -ge 1 ]; do
    case $1 in
    --apply)	APPLY=1;;
    --remove)	REMOVE=1;;
    --dry-run)	DRYRUN='--dry-run';;
    *)		echo "Usage `basename $0` [--apply|--remove|--dry-run]"
		exit 1;;
    esac
    shift
done

if [ $REMOVE != 0 ]; then
	echo Removing patches
	patch -p0 -R ${DRYRUN} < ${patch}
	rm -f ${patch}
fi

if [ $APPLY != 0 ]; then
	echo Applying patches
	utils/gen_prefs_patch.pl ~/src/icewm-1.0.1 . > ${patch}
	patch -p0 ${DRYRUN} < ${patch}
fi
